/*!	@file
	@brief Ruby Library Handler

	Ruby𗘗p邽߂̃C^[tF[X

	@author Sakura-Editor collaborators
	@date 2013.12.16
*/
/*
	Copyright (C) 2013, Sakura-Editor collaborators

	This software is provided 'as-is', without any express or implied
	warranty. In no event will the authors be held liable for any damages
	arising from the use of this software.

	Permission is granted to anyone to use this software for any purpose, 
	including commercial applications, and to alter it and redistribute it 
	freely, subject to the following restrictions:

		1. The origin of this software must not be misrepresented;
		   you must not claim that you wrote the original software.
		   If you use this software in a product, an acknowledgment
		   in the product documentation would be appreciated but is
		   not required.

		2. Altered source versions must be plainly marked as such, 
		   and must not be misrepresented as being the original software.

		3. This notice may not be removed or altered from any source
		   distribution.
*/
/*
	msvcrt-ruby200.dllsakura.exeƓtH_ɒuĂB
	Ruby2.0płBRub1.9ȉAPIႤߗpł܂B
	XNvgł́A
		print Editor.InsText('hello')
	̂悤Editorɑă\bhLqĂB
	EditornewKv͂܂B
	"1"Ŏn܂郁\bh"One", "S_1"Ŏn܂郁\bhɂĂ܂A

	TODO:
	self.namê悤Ƀ\bh擾ł΃nh点܂A@킩܂B
	nĥŃrhɎق܂B
*/

#include "StdAfx.h"
#include "CRuby.h"
#include "view/CEditView.h"
#include "func/Funccode.h"
#include "CMacro.h"
#include "macro/CSMacroMgr.h"
#include "env/CShareData.h"
#include "env/DLLSHAREDATA.h"
#include "_os/OleTypes.h"
#include "util/string_ex.h"
#include "charset/CUtf8.h"

///////////////////////////////////////////////////////////////////////////////
enum RubySpecialConsts {
	RUBY_Qfalse   = 0,
	RUBY_Qtrue    = 2,
	RUBY_Qnil     = 4,
	RUBY_Qundef   = 6
};

enum RubyValueType {
	RUBY_T_NONE   = 0x00,
	RUBY_T_OBJECT = 0x01,
	RUBY_T_CLASS  = 0x02,
	RUBY_T_FLOAT  = 0x04,
	RUBY_T_STRING = 0x05,
	RUBY_T_ARRAY  = 0x07,
	RUBY_T_BIGNUM = 0x0a,
	RUBY_T_NIL    = 0x11,
	RUBY_T_TRUE   = 0x12,
	RUBY_T_FALSE  = 0x13,
    RUBY_T_SYMBOL = 0x14,
	RUBY_T_FIXNUM = 0x15,
	RUBY_T_UNDEF  = 0x1b,
	RUBY_T_MASK   = 0x1f
};

#define Qfalse ((VALUE)RUBY_Qfalse)
#define Qtrue  ((VALUE)RUBY_Qtrue)
#define Qnil   ((VALUE)RUBY_Qnil)
#define Qundef ((VALUE)RUBY_Qundef)

///////////////////////////////////////////////////////////////////////////////
class CRubyCommandHandlerParam
{
public:
	int			m_nArgs;
	LPCWSTR*	ParamArguments;		//ParamStrings[]̃|C^ێ邾
	int*		ParamArgLengths;
	CMemory*	ParamStrings;

	CRubyCommandHandlerParam(const int nArgs){
		m_nArgs = nArgs;
		ParamArguments  = NULL;
		ParamArgLengths = NULL;
		ParamStrings    = NULL;
		if(nArgs > 0){
			ParamArguments  = new LPCWSTR[nArgs];
			ParamArgLengths = new int[nArgs];
			ParamStrings    = new CMemory[nArgs];
			for(int i = 0; i < nArgs; i++){
				ParamArguments[i]  = NULL;
				ParamArgLengths[i] = 0;
			}
		}
	}

	virtual ~CRubyCommandHandlerParam(){
		Clear();
	}

	void Clear(){
		if(ParamArguments  != NULL){
			delete[] ParamArguments;
			ParamArguments = NULL;
		}
		if(ParamArgLengths != NULL){
			delete[] ParamArgLengths;
			ParamArgLengths = NULL;
		}
		if(ParamStrings    != NULL){
			delete[] ParamStrings;
			ParamStrings = NULL;
		}
		m_nArgs = 0;
	}

	void Set(const int nIndex, const char* utf8str){
		ParamArguments[nIndex]  = CRuby::UTF8ToUnicode(ParamStrings[nIndex], utf8str);
		ParamArgLengths[nIndex] = wcslen(ParamArguments[nIndex]);
	}
};

///////////////////////////////////////////////////////////////////////////////
class CRubyFunctionHandlerParam
{
public:
	int			m_nArgs;
	VARIANT*	vtArguments;
	VARIANT		vtResult;

	CRubyFunctionHandlerParam(const int nArgs){
		m_nArgs = nArgs;
		vtArguments = NULL;
		if(nArgs > 0){
			vtArguments = new VARIANT[nArgs];
			for(int i = 0; i < nArgs; i++){
				::VariantInit(&vtArguments[i]);
			}
		}
		::VariantInit(&vtResult);
	}

	virtual ~CRubyFunctionHandlerParam(){
		Clear();
	}

	void Clear(){
		if(m_nArgs > 0){
			for(int i = 0; i < m_nArgs; i++){
				::VariantClear(&vtArguments[i]);
			}
			delete[] vtArguments;
			vtArguments = NULL;
		}
		::VariantClear(&vtResult);
		m_nArgs = 0;
	}

	void Set(const int nIndex, const long lValue){
		vtArguments[nIndex].vt = VT_I4;
		vtArguments[nIndex].lVal = lValue;
	}

	void Set(const int nIndex, const wchar_t* strValue){
		vtArguments[nIndex].vt = VT_BSTR;
		vtArguments[nIndex].bstrVal = ::SysAllocString(strValue);
	}
};

///////////////////////////////////////////////////////////////////////////////
CRuby::RubyExecInfo* CRuby::m_CurrentInstance = NULL;
#ifdef PROHIBIT_REENTRANT_RUBY
bool CRuby::m_bRunning = false;
#endif
int CRuby::m_argc = 1;
char* CRuby::m_argv[1] = { "" };

///////////////////////////////////////////////////////////////////////////////
CRuby::CRuby()
{
}

///////////////////////////////////////////////////////////////////////////////
CRuby::~CRuby()
{
}

///////////////////////////////////////////////////////////////////////////////
LPCWSTR CRuby::GetVersion()
{
	if(IsAvailable()){
		wchar_t szBuffer[256];
		swprintf(szBuffer, L"%s Version %d.%d.%d", GetDllNameImp(0), m_val_ruby_api_version[0], m_val_ruby_api_version[1], m_val_ruby_api_version[2]);
		m_strErrorMsg = szBuffer;
		return m_strErrorMsg.c_str();
	}
	return L"";
}

///////////////////////////////////////////////////////////////////////////////
LPCWSTR CRuby::GetLastMessage(void) const
{
	return m_strErrorMsg.c_str();
}

///////////////////////////////////////////////////////////////////////////////
LPCTSTR CRuby::GetDllNameImp(int nIndex)
{
	LPCTSTR name[] = {
		_T("msvcrt-ruby200.dll"),
		_T("msvcrt-ruby.dll"),
		_T("ruby.dll"),
		NULL
	};
	return name[nIndex];
}

///////////////////////////////////////////////////////////////////////////////
/*!	DLL
*/
bool CRuby::InitDllImp()
{
	//DLLĂ֐
	const ImportTable table[] = {
		{ &m_fn_ruby_sysinit,				"ruby_sysinit" },
		{ &m_fn_ruby_init,					"ruby_init" },
		{ &m_fn_ruby_init_loadpath,			"ruby_init_loadpath" },
		{ &m_fn_ruby_cleanup,				"ruby_cleanup" },
		{ &m_fn_rb_load,					"rb_load" },
		{ &m_fn_rb_load_protect,			"rb_load_protect" },
		{ &m_fn_rb_str_new,					"rb_str_new" },
		{ &m_fn_rb_str_new2,				"rb_str_new2" },
		{ &m_fn_rb_eval_string_protect,		"rb_eval_string_protect" },
		{ &m_fn_rb_errinfo,					"rb_errinfo" },
		{ &m_fn_rb_set_errinfo,				"rb_set_errinfo" },
		{ &m_fn_rb_obj_as_string,			"rb_obj_as_string" },
		{ &m_fn_rb_sourceline,				"rb_sourceline" },
		{ &m_fn_rb_sourcefile,				"rb_sourcefile" },
		{ &m_fn_rb_string_value_cstr,		"rb_string_value_cstr" },
		{ &m_fn_rb_define_global_function,	"rb_define_global_function" },
		{ &m_fn_rb_define_class,			"rb_define_class" },
		{ &m_fn_rb_define_method,			"rb_define_method" },
		{ &m_fn_rb_define_protected_method,	"rb_define_protected_method" },
		{ &m_fn_rb_define_private_method,	"rb_define_private_method" },
		{ &m_fn_rb_define_singleton_method,	"rb_define_singleton_method" },
		{ &m_fn_rb_singleton_class,			"rb_singleton_class" },
		{ &m_fn_rb_iv_set,					"rb_iv_set" },
		{ &m_fn_rb_iv_get,					"rb_iv_get" },
		{ &m_fn_rb_raise,					"rb_raise" },
		{ &m_fn_rb_fix2int,					"rb_fix2int" },
		{ &m_fn_rb_check_type,				"rb_check_type" },

		{ &m_val_ruby_api_version,			"ruby_api_version" },
		{ &m_val_ruby_version,				"ruby_version" },
		{ &m_val_rb_cObject,				"rb_cObject" },
		{ &m_val_rb_eRuntimeError,			"rb_eRuntimeError" },
		{ &m_val_rb_eTypeError,				"rb_eTypeError" },

		{ NULL, 0 }
	};

	if(RegisterEntries(table) == false){
		return false;
	}

	ruby_sysinit(&m_argc, (char***)&m_argv);	//WinMain͕Kv
	ruby_init();
	SetMethods();

	return true;
}

///////////////////////////////////////////////////////////////////////////////
bool CRuby::DeinitDllImp()
{
	ruby_cleanup(0);
	return true;
}


///////////////////////////////////////////////////////////////////////////////
// ̌^擾(gΉ)
DWORD CRuby::GetType(const struct MacroFuncInfo* info, const int nIndex)
{
	if(nIndex < 4){
		return info->m_varArguments[nIndex];
	}
	MacroFuncInfoEx* exp = (MacroFuncInfoEx*)info->m_pData;
	if(exp != NULL){
		if(nIndex < exp->m_nArgSize){
			return exp->m_pVarArgEx[nIndex - 4];
		}
	}
	return VT_EMPTY;
}

///////////////////////////////////////////////////////////////////////////////
// ̐擾(gΉ)
int CRuby::GetNumArgs(const struct MacroFuncInfo* info)
{
	int nArgs = 0;
	MacroFuncInfoEx* exp = (MacroFuncInfoEx*)info->m_pData;
	if(exp != NULL){
		nArgs = exp->m_nArgSize;
	}else{
		for(nArgs = 0; nArgs < 4; nArgs++){
			if(info->m_varArguments[nArgs] == VT_EMPTY) break;
		}
	}
	return nArgs;
}

///////////////////////////////////////////////////////////////////////////////
const wchar_t* CRuby::UTF8ToUnicode(CMemory& cmUnicodeStr, const char* utf8str)
{
	cmUnicodeStr.SetRawData(utf8str, lstrlenA(utf8str) * sizeof(char));
	CUtf8::UTF8ToUnicode(&cmUnicodeStr);
	return (const wchar_t*)cmUnicodeStr.GetRawPtr();
}

///////////////////////////////////////////////////////////////////////////////
const char* CRuby::UnicodeToUTF8(CMemory& cmUtf8Str, const wchar_t* unicodestr)
{
	cmUtf8Str.SetRawData(unicodestr, wcslen(unicodestr) * sizeof(wchar_t));
	CUtf8::UnicodeToUTF8(&cmUtf8Str);
	return (const char*)cmUtf8Str.GetRawPtr();
}

///////////////////////////////////////////////////////////////////////////////
/*!	XNvgs
	@param[in]	code		XNvg
	@param[in]	pcEditView	r[
	@param[in]	flags		tO
*/
bool CRuby::Execute(const char* code, CEditView* pcEditView, int flags)
{
#ifdef PROHIBIT_REENTRANT_RUBY
	if(m_bRunning){
		MYMESSAGEBOX(pcEditView->GetHwnd(), MB_OK, _T("RubysG["), _T("RubyXNvgsɐVRubyXNvgĂяoƂ͂ł܂"));
		return false;
	}
	m_bRunning = true;
#endif

	//Ϗ񂪓Ƃ̂ߌĂяoɊǗpӂĂ
	RubyExecInfo info;
	info.m_pcEditView    = pcEditView;
	info.m_nCommandFlags = flags | FA_FROMMACRO;
	info.m_lpRuby        = this;

	int state = 0;
	m_strErrorMsg = L"";

//	ruby_sysinit(&m_argc, (char***)&m_argv);
//	ruby_init();
//	SetMethods();

	RubyExecInfo* prevInstance = m_CurrentInstance;
	m_CurrentInstance = &info;
	rb_eval_string_protect(code, &state);
	if(state != 0){
		//G[i[
		VALUE err = rb_errinfo();
		err = rb_obj_as_string(err);
		CMemory cmString;
		m_strErrorMsg = CRuby::UTF8ToUnicode(cmString, StringValueCStr(err));
		m_strSourceFile = CRuby::UTF8ToUnicode(cmString, rb_sourcefile());
		m_nSourceLine = rb_sourceline();
		rb_set_errinfo(Qnil);	//G[̃NA

		std::wstring strCaption = m_strErrorMsg + L"\n\nFile: " + m_strSourceFile + L"\n";
		wchar_t szBuffer[256];
		swprintf(szBuffer, L"Line: %d", m_nSourceLine);
		strCaption += szBuffer;
		MYMESSAGEBOX(pcEditView->GetHwnd(), MB_OK, _T("RubysG["), strCaption.c_str());
	}
	m_CurrentInstance = prevInstance;

//	ruby_cleanup(0);

#ifdef PROHIBIT_REENTRANT_RUBY
	m_bRunning = false;
#endif

	return (state == 0);
}

///////////////////////////////////////////////////////////////////////////////
VALUE CRuby::CommandHandler(DWORD nFuncID, VALUE Arguments[], int nArgSize)
{
	bool bRet = false;
	CRubyCommandHandlerParam param(nArgSize);
	for(int i = 0; i < nArgSize; i++){
		param.Set(i, m_CurrentInstance->m_lpRuby->StringValueCStr(Arguments[i]));
	}

	bRet = CMacro::HandleCommand(m_CurrentInstance->m_pcEditView, (EFunctionCode)(nFuncID | m_CurrentInstance->m_nCommandFlags), (LPCWSTR*)param.ParamArguments, param.ParamArgLengths, nArgSize);

	if(!bRet){
		param.Clear();
		char szBuffer[256];
		sprintf(szBuffer, "Failed to call HandleCommand(ID=%d).", nFuncID);
		m_CurrentInstance->m_lpRuby->rb_raise(m_CurrentInstance->m_lpRuby->rb_eRuntimeError(), szBuffer);
		//not reached?
	}
	return Qnil;
}

///////////////////////////////////////////////////////////////////////////////
VALUE CRuby::FunctionHandler(DWORD nFuncID, VALUE* Arguments, int nArgSize)
{
	bool bRet = false;
	CRubyFunctionHandlerParam param(nArgSize);

	const struct MacroFuncInfo* info = CSMacroMgr::GetFuncInfoByID(nFuncID);
	if(GetNumArgs(info) != nArgSize) goto ExitHandler;

	for(int i = 0; i < nArgSize; i++){
		switch(GetType(info, i)){
		case VT_I4:
			m_CurrentInstance->m_lpRuby->rb_check_type(Arguments[i], RUBY_T_FIXNUM);	//raise error
			param.Set(i, m_CurrentInstance->m_lpRuby->rb_fix2int(Arguments[i]));
			break;
		case VT_BSTR:
			{
				m_CurrentInstance->m_lpRuby->rb_check_type(Arguments[i], RUBY_T_STRING);	//raise error
				const char* utf8str = m_CurrentInstance->m_lpRuby->StringValueCStr(Arguments[i]);
				CMemory cmString;
				param.Set(i, CRuby::UTF8ToUnicode(cmString, utf8str));
			}
			break;
		default:
			goto ExitHandler;
		}
	}

	bRet = CMacro::HandleFunction(m_CurrentInstance->m_pcEditView, (EFunctionCode)nFuncID, param.vtArguments, nArgSize, param.vtResult);

ExitHandler:
	if(!bRet){
		param.Clear();
		char szBuffer[256];
		sprintf(szBuffer, "Failed to call HandleFunction(ID=%d).", nFuncID);
		m_CurrentInstance->m_lpRuby->rb_raise(m_CurrentInstance->m_lpRuby->rb_eRuntimeError(), szBuffer);
		//not reached?
	}
	return (BOOL)bRet;
}

///////////////////////////////////////////////////////////////////////////////
void CRuby::SetMethods()
{
	VALUE Editor = rb_define_class("Editor", rb_rcObject());

	//Commands
	rb_define_singleton_method(Editor, "FileNew", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileNew), 0);
	rb_define_singleton_method(Editor, "FileOpen", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileOpen), 4);
	rb_define_singleton_method(Editor, "FileSave", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileSave), 0);
	rb_define_singleton_method(Editor, "FileSaveAll", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileSaveAll), 0);
	rb_define_singleton_method(Editor, "FileSaveAsDialog", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileSaveAsDialog), 3);
	rb_define_singleton_method(Editor, "FileSaveAs", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileSaveAs), 3);
	rb_define_singleton_method(Editor, "FileClose", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileClose), 0);
	rb_define_singleton_method(Editor, "FileCloseOpen", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileCloseOpen), 0);
	rb_define_singleton_method(Editor, "FileReopen", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileReopen), 1);
	rb_define_singleton_method(Editor, "FileReopenSJIS", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileReopenSJIS), 1);
	rb_define_singleton_method(Editor, "FileReopenJIS", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileReopenJIS), 1);
	rb_define_singleton_method(Editor, "FileReopenEUC", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileReopenEUC), 1);
	rb_define_singleton_method(Editor, "FileReopenLatin1", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileReopenLatin1), 1);
	rb_define_singleton_method(Editor, "FileReopenUNICODE", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileReopenUNICODE), 1);
	rb_define_singleton_method(Editor, "FileReopenUNICODEBE", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileReopenUNICODEBE), 1);
	rb_define_singleton_method(Editor, "FileReopenUTF8", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileReopenUTF8), 1);
	rb_define_singleton_method(Editor, "FileReopenCESU8", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileReopenCESU8), 1);
	rb_define_singleton_method(Editor, "FileReopenUTF7", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileReopenUTF7), 1);
	rb_define_singleton_method(Editor, "Print", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Print), 0);
	rb_define_singleton_method(Editor, "PrintPreview", reinterpret_cast<VALUE(__cdecl *)(...)>(S_PrintPreview), 0);
	rb_define_singleton_method(Editor, "PrintPageSetup", reinterpret_cast<VALUE(__cdecl *)(...)>(S_PrintPageSetup), 0);
	rb_define_singleton_method(Editor, "OpenHfromtoC", reinterpret_cast<VALUE(__cdecl *)(...)>(S_OpenHfromtoC), 0);
	rb_define_singleton_method(Editor, "ActivateSQLPLUS", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ActivateSQLPLUS), 0);
	rb_define_singleton_method(Editor, "ExecSQLPLUS", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ExecSQLPLUS), 0);
	rb_define_singleton_method(Editor, "Browse", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Browse), 0);
	rb_define_singleton_method(Editor, "ViewMode", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ViewMode), 0);
	rb_define_singleton_method(Editor, "ReadOnly", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ReadOnly), 0);
	rb_define_singleton_method(Editor, "PropertyFile", reinterpret_cast<VALUE(__cdecl *)(...)>(S_PropertyFile), 0);
	rb_define_singleton_method(Editor, "ExitAllEditors", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ExitAllEditors), 0);
	rb_define_singleton_method(Editor, "ExitAll", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ExitAll), 0);
	rb_define_singleton_method(Editor, "PutFile", reinterpret_cast<VALUE(__cdecl *)(...)>(S_PutFile), 3);
	rb_define_singleton_method(Editor, "InsFile", reinterpret_cast<VALUE(__cdecl *)(...)>(S_InsFile), 3);
	rb_define_singleton_method(Editor, "Char", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Char), 1);
	rb_define_singleton_method(Editor, "CharIme", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CharIme), 1);
	rb_define_singleton_method(Editor, "Undo", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Undo), 0);
	rb_define_singleton_method(Editor, "Redo", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Redo), 0);
	rb_define_singleton_method(Editor, "Delete", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Delete), 0);
	rb_define_singleton_method(Editor, "DeleteBack", reinterpret_cast<VALUE(__cdecl *)(...)>(S_DeleteBack), 0);
	rb_define_singleton_method(Editor, "WordDeleteToStart", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WordDeleteToStart), 0);
	rb_define_singleton_method(Editor, "WordDeleteToEnd", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WordDeleteToEnd), 0);
	rb_define_singleton_method(Editor, "WordCut", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WordCut), 0);
	rb_define_singleton_method(Editor, "WordDelete", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WordDelete), 0);
	rb_define_singleton_method(Editor, "LineCutToStart", reinterpret_cast<VALUE(__cdecl *)(...)>(S_LineCutToStart), 0);
	rb_define_singleton_method(Editor, "LineCutToEnd", reinterpret_cast<VALUE(__cdecl *)(...)>(S_LineCutToEnd), 0);
	rb_define_singleton_method(Editor, "LineDeleteToStart", reinterpret_cast<VALUE(__cdecl *)(...)>(S_LineDeleteToStart), 0);
	rb_define_singleton_method(Editor, "LineDeleteToEnd", reinterpret_cast<VALUE(__cdecl *)(...)>(S_LineDeleteToEnd), 0);
	rb_define_singleton_method(Editor, "CutLine", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CutLine), 0);
	rb_define_singleton_method(Editor, "DeleteLine", reinterpret_cast<VALUE(__cdecl *)(...)>(S_DeleteLine), 0);
	rb_define_singleton_method(Editor, "DuplicateLine", reinterpret_cast<VALUE(__cdecl *)(...)>(S_DuplicateLine), 0);
	rb_define_singleton_method(Editor, "IndentTab", reinterpret_cast<VALUE(__cdecl *)(...)>(S_IndentTab), 0);
	rb_define_singleton_method(Editor, "UnindentTab", reinterpret_cast<VALUE(__cdecl *)(...)>(S_UnindentTab), 0);
	rb_define_singleton_method(Editor, "IndentSpace", reinterpret_cast<VALUE(__cdecl *)(...)>(S_IndentSpace), 0);
	rb_define_singleton_method(Editor, "UnindentSpace", reinterpret_cast<VALUE(__cdecl *)(...)>(S_UnindentSpace), 0);
	rb_define_singleton_method(Editor, "LTrim", reinterpret_cast<VALUE(__cdecl *)(...)>(S_LTrim), 0);
	rb_define_singleton_method(Editor, "RTrim", reinterpret_cast<VALUE(__cdecl *)(...)>(S_RTrim), 0);
	rb_define_singleton_method(Editor, "SortAsc", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SortAsc), 0);
	rb_define_singleton_method(Editor, "SortDesc", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SortDesc), 0);
	rb_define_singleton_method(Editor, "Merge", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Merge), 0);
	rb_define_singleton_method(Editor, "Up", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Up), 0);
	rb_define_singleton_method(Editor, "Down", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Down), 0);
	rb_define_singleton_method(Editor, "Left", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Left), 0);
	rb_define_singleton_method(Editor, "Right", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Right), 0);
	rb_define_singleton_method(Editor, "Up2", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Up2), 0);
	rb_define_singleton_method(Editor, "Down2", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Down2), 0);
	rb_define_singleton_method(Editor, "WordLeft", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WordLeft), 0);
	rb_define_singleton_method(Editor, "WordRight", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WordRight), 0);
	rb_define_singleton_method(Editor, "GoLineTop", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GoLineTop), 1);
	rb_define_singleton_method(Editor, "GoLineEnd", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GoLineEnd), 1);
	rb_define_singleton_method(Editor, "HalfPageUp", reinterpret_cast<VALUE(__cdecl *)(...)>(S_HalfPageUp), 0);
	rb_define_singleton_method(Editor, "HalfPageDown", reinterpret_cast<VALUE(__cdecl *)(...)>(S_HalfPageDown), 0);
	rb_define_singleton_method(Editor, "PageUp", reinterpret_cast<VALUE(__cdecl *)(...)>(S_PageUp), 0);
	rb_define_singleton_method(Editor, "OnePageUp", reinterpret_cast<VALUE(__cdecl *)(...)>(S_1PageUp), 0);
		rb_define_singleton_method(Editor, "S_1PageUp", reinterpret_cast<VALUE(__cdecl *)(...)>(S_1PageUp), 0);
	rb_define_singleton_method(Editor, "PageDown", reinterpret_cast<VALUE(__cdecl *)(...)>(S_PageDown), 0);
	rb_define_singleton_method(Editor, "OnePageDown", reinterpret_cast<VALUE(__cdecl *)(...)>(S_1PageDown), 0);
		rb_define_singleton_method(Editor, "S_1PageDown", reinterpret_cast<VALUE(__cdecl *)(...)>(S_1PageDown), 0);
	rb_define_singleton_method(Editor, "GoFileTop", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GoFileTop), 0);
	rb_define_singleton_method(Editor, "GoFileEnd", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GoFileEnd), 0);
	rb_define_singleton_method(Editor, "CurLineCenter", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CurLineCenter), 0);
	rb_define_singleton_method(Editor, "MoveHistPrev", reinterpret_cast<VALUE(__cdecl *)(...)>(S_MoveHistPrev), 0);
	rb_define_singleton_method(Editor, "MoveHistNext", reinterpret_cast<VALUE(__cdecl *)(...)>(S_MoveHistNext), 0);
	rb_define_singleton_method(Editor, "MoveHistSet", reinterpret_cast<VALUE(__cdecl *)(...)>(S_MoveHistSet), 0);
	rb_define_singleton_method(Editor, "F_WndScrollDown", reinterpret_cast<VALUE(__cdecl *)(...)>(S_F_WndScrollDown), 0);
	rb_define_singleton_method(Editor, "F_WndScrollUp", reinterpret_cast<VALUE(__cdecl *)(...)>(S_F_WndScrollUp), 0);
	rb_define_singleton_method(Editor, "GoNextParagraph", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GoNextParagraph), 0);
	rb_define_singleton_method(Editor, "GoPrevParagraph", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GoPrevParagraph), 0);
	rb_define_singleton_method(Editor, "MoveCursor", reinterpret_cast<VALUE(__cdecl *)(...)>(S_MoveCursor), 3);
	rb_define_singleton_method(Editor, "MoveCursorLayout", reinterpret_cast<VALUE(__cdecl *)(...)>(S_MoveCursorLayout), 3);
	rb_define_singleton_method(Editor, "WhellUp", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WhellUp), 1);
	rb_define_singleton_method(Editor, "WhellDown", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WhellDown), 1);
	rb_define_singleton_method(Editor, "WhellLeft", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WhellLeft), 1);
	rb_define_singleton_method(Editor, "WhellRight", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WhellRight), 1);
	rb_define_singleton_method(Editor, "WhellPageUp", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WhellPageUp), 1);
	rb_define_singleton_method(Editor, "WhellPageDown", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WhellPageDown), 1);
	rb_define_singleton_method(Editor, "WhellPageLeft", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WhellPageLeft), 1);
	rb_define_singleton_method(Editor, "WhellPageRight", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WhellPageRight), 1);
	rb_define_singleton_method(Editor, "SelectWord", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SelectWord), 0);
	rb_define_singleton_method(Editor, "SelectAll", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SelectAll), 0);
	rb_define_singleton_method(Editor, "SelectLine", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SelectLine), 1);
	rb_define_singleton_method(Editor, "BeginSelect", reinterpret_cast<VALUE(__cdecl *)(...)>(S_BeginSelect), 0);
	rb_define_singleton_method(Editor, "Up_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Up_Sel), 0);
	rb_define_singleton_method(Editor, "Down_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Down_Sel), 0);
	rb_define_singleton_method(Editor, "Left_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Left_Sel), 0);
	rb_define_singleton_method(Editor, "Right_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Right_Sel), 0);
	rb_define_singleton_method(Editor, "Up2_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Up2_Sel), 0);
	rb_define_singleton_method(Editor, "Down2_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Down2_Sel), 0);
	rb_define_singleton_method(Editor, "WordLeft_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WordLeft_Sel), 0);
	rb_define_singleton_method(Editor, "WordRight_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WordRight_Sel), 0);
	rb_define_singleton_method(Editor, "GoLineTop_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GoLineTop_Sel), 1);
	rb_define_singleton_method(Editor, "GoLineEnd_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GoLineEnd_Sel), 1);
	rb_define_singleton_method(Editor, "HalfPageUp_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_HalfPageUp_Sel), 0);
	rb_define_singleton_method(Editor, "HalfPageDown_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_HalfPageDown_Sel), 0);
	rb_define_singleton_method(Editor, "PageUp_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_PageUp_Sel), 0);
	rb_define_singleton_method(Editor, "OnePageUp_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_1PageUp_Sel), 0);
		rb_define_singleton_method(Editor, "S_1PageUp_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_1PageUp_Sel), 0);
	rb_define_singleton_method(Editor, "PageDown_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_PageDown_Sel), 0);
	rb_define_singleton_method(Editor, "OnePageDown_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_1PageDown_Sel), 0);
		rb_define_singleton_method(Editor, "S_1PageDown_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_1PageDown_Sel), 0);
	rb_define_singleton_method(Editor, "GoFileTop_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GoFileTop_Sel), 0);
	rb_define_singleton_method(Editor, "GoFileEnd_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GoFileEnd_Sel), 0);
	rb_define_singleton_method(Editor, "GoNextParagraph_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GoNextParagraph_Sel), 0);
	rb_define_singleton_method(Editor, "GoPrevParagraph_Sel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GoPrevParagraph_Sel), 0);
	rb_define_singleton_method(Editor, "BeginBoxSelect", reinterpret_cast<VALUE(__cdecl *)(...)>(S_BeginBoxSelect), 0);
	rb_define_singleton_method(Editor, "Up_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Up_BoxSel), 0);
	rb_define_singleton_method(Editor, "Down_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Down_BoxSel), 0);
	rb_define_singleton_method(Editor, "Left_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Left_BoxSel), 0);
	rb_define_singleton_method(Editor, "Right_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Right_BoxSel), 0);
	rb_define_singleton_method(Editor, "Up2_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Up2_BoxSel), 0);
	rb_define_singleton_method(Editor, "Down2_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Down2_BoxSel), 0);
	rb_define_singleton_method(Editor, "WordLeft_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WordLeft_BoxSel), 0);
	rb_define_singleton_method(Editor, "WordRight_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WordRight_BoxSel), 0);
	rb_define_singleton_method(Editor, "GoLogicalLineTop_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GoLogicalLineTop_BoxSel), 1);
	rb_define_singleton_method(Editor, "GoLineTop_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GoLineTop_BoxSel), 1);
	rb_define_singleton_method(Editor, "GoLineEnd_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GoLineEnd_BoxSel), 1);
	rb_define_singleton_method(Editor, "HalfPageUp_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_HalfPageUp_BoxSel), 0);
	rb_define_singleton_method(Editor, "HalfPageDown_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_HalfPageDown_BoxSel), 0);
	rb_define_singleton_method(Editor, "PageUp_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_PageUp_BoxSel), 0);
	rb_define_singleton_method(Editor, "OnePageUp_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_1PageUp_BoxSel), 0);
		rb_define_singleton_method(Editor, "S_1PageUp_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_1PageUp_BoxSel), 0);
	rb_define_singleton_method(Editor, "PageDown_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_PageDown_BoxSel), 0);
	rb_define_singleton_method(Editor, "OnePageDown_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_1PageDown_BoxSel), 0);
		rb_define_singleton_method(Editor, "S_1PageDown_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_1PageDown_BoxSel), 0);
	rb_define_singleton_method(Editor, "GoFileTop_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GoFileTop_BoxSel), 0);
	rb_define_singleton_method(Editor, "GoFileEnd_BoxSel", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GoFileEnd_BoxSel), 0);
	rb_define_singleton_method(Editor, "Cut", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Cut), 0);
	rb_define_singleton_method(Editor, "Copy", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Copy), 0);
	rb_define_singleton_method(Editor, "Paste", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Paste), 1);
	rb_define_singleton_method(Editor, "CopyAddCRLF", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CopyAddCRLF), 0);
	rb_define_singleton_method(Editor, "CopyCRLF", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CopyCRLF), 0);
	rb_define_singleton_method(Editor, "PasteBox", reinterpret_cast<VALUE(__cdecl *)(...)>(S_PasteBox), 1);
	rb_define_singleton_method(Editor, "InsBoxText", reinterpret_cast<VALUE(__cdecl *)(...)>(S_InsBoxText), 1);
	rb_define_singleton_method(Editor, "InsText", reinterpret_cast<VALUE(__cdecl *)(...)>(S_InsText), 1);
	rb_define_singleton_method(Editor, "AddTail", reinterpret_cast<VALUE(__cdecl *)(...)>(S_AddTail), 1);
	rb_define_singleton_method(Editor, "CopyLines", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CopyLines), 0);
	rb_define_singleton_method(Editor, "CopyLinesAsPassage", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CopyLinesAsPassage), 0);
	rb_define_singleton_method(Editor, "CopyLinesWithLineNumber", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CopyLinesWithLineNumber), 0);
	rb_define_singleton_method(Editor, "CopyColorHtml", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CopyColorHtml), 0);
	rb_define_singleton_method(Editor, "CopyColorHtmlWithLineNumber", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CopyColorHtmlWithLineNumber), 0);
	rb_define_singleton_method(Editor, "CopyPath", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CopyPath), 0);
	rb_define_singleton_method(Editor, "CopyFilename", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CopyFilename), 0);
	rb_define_singleton_method(Editor, "CopyTag", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CopyTag), 0);
	rb_define_singleton_method(Editor, "CopyKeyBindList", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CopyKeyBindList), 0);
	rb_define_singleton_method(Editor, "InsertDate", reinterpret_cast<VALUE(__cdecl *)(...)>(S_InsertDate), 0);
	rb_define_singleton_method(Editor, "InsertTime", reinterpret_cast<VALUE(__cdecl *)(...)>(S_InsertTime), 0);
	rb_define_singleton_method(Editor, "CtrlCodeDialog", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CtrlCodeDialog), 0);
	rb_define_singleton_method(Editor, "ToLower", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ToLower), 0);
	rb_define_singleton_method(Editor, "ToUpper", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ToUpper), 0);
	rb_define_singleton_method(Editor, "ToHankaku", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ToHankaku), 0);
	rb_define_singleton_method(Editor, "ToHankata", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ToHankata), 0);
	rb_define_singleton_method(Editor, "ToZenEi", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ToZenEi), 0);
	rb_define_singleton_method(Editor, "ToHanEi", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ToHanEi), 0);
	rb_define_singleton_method(Editor, "ToZenKata", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ToZenKata), 0);
	rb_define_singleton_method(Editor, "ToZenHira", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ToZenHira), 0);
	rb_define_singleton_method(Editor, "HanKataToZenKata", reinterpret_cast<VALUE(__cdecl *)(...)>(S_HanKataToZenKata), 0);
	rb_define_singleton_method(Editor, "HanKataToZenHira", reinterpret_cast<VALUE(__cdecl *)(...)>(S_HanKataToZenHira), 0);
	rb_define_singleton_method(Editor, "TABToSPACE", reinterpret_cast<VALUE(__cdecl *)(...)>(S_TABToSPACE), 0);
	rb_define_singleton_method(Editor, "SPACEToTAB", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SPACEToTAB), 0);
	rb_define_singleton_method(Editor, "AutoToSJIS", reinterpret_cast<VALUE(__cdecl *)(...)>(S_AutoToSJIS), 0);
	rb_define_singleton_method(Editor, "JIStoSJIS", reinterpret_cast<VALUE(__cdecl *)(...)>(S_JIStoSJIS), 0);
	rb_define_singleton_method(Editor, "EUCtoSJIS", reinterpret_cast<VALUE(__cdecl *)(...)>(S_EUCtoSJIS), 0);
	rb_define_singleton_method(Editor, "CodeCnvUNICODEtoSJIS", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CodeCnvUNICODEtoSJIS), 0);
	rb_define_singleton_method(Editor, "CodeCnvUNICODEBEtoSJIS", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CodeCnvUNICODEBEtoSJIS), 0);
	rb_define_singleton_method(Editor, "UTF8toSJIS", reinterpret_cast<VALUE(__cdecl *)(...)>(S_UTF8toSJIS), 0);
	rb_define_singleton_method(Editor, "UTF7toSJIS", reinterpret_cast<VALUE(__cdecl *)(...)>(S_UTF7toSJIS), 0);
	rb_define_singleton_method(Editor, "SJIStoJIS", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SJIStoJIS), 0);
	rb_define_singleton_method(Editor, "SJIStoEUC", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SJIStoEUC), 0);
	rb_define_singleton_method(Editor, "SJIStoUTF8", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SJIStoUTF8), 0);
	rb_define_singleton_method(Editor, "SJIStoUTF7", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SJIStoUTF7), 0);
	rb_define_singleton_method(Editor, "Base64Decode", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Base64Decode), 0);
	rb_define_singleton_method(Editor, "Uudecode", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Uudecode), 0);
	rb_define_singleton_method(Editor, "SearchDialog", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SearchDialog), 0);
	rb_define_singleton_method(Editor, "SearchNext", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SearchNext), 2);
	rb_define_singleton_method(Editor, "SearchPrev", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SearchPrev), 2);
	rb_define_singleton_method(Editor, "ReplaceDialog", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ReplaceDialog), 0);
	rb_define_singleton_method(Editor, "Replace", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Replace), 3);
	rb_define_singleton_method(Editor, "ReplaceAll", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ReplaceAll), 3);
	rb_define_singleton_method(Editor, "SearchClearMark", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SearchClearMark), 0);
	rb_define_singleton_method(Editor, "SearchStartPos", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SearchStartPos), 0);
	rb_define_singleton_method(Editor, "Grep", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Grep), 5);
	rb_define_singleton_method(Editor, "Jump", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Jump), 2);
	rb_define_singleton_method(Editor, "Outline", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Outline), 1);
	rb_define_singleton_method(Editor, "TagJump", reinterpret_cast<VALUE(__cdecl *)(...)>(S_TagJump), 0);
	rb_define_singleton_method(Editor, "TagJumpBack", reinterpret_cast<VALUE(__cdecl *)(...)>(S_TagJumpBack), 0);
	rb_define_singleton_method(Editor, "TagMake", reinterpret_cast<VALUE(__cdecl *)(...)>(S_TagMake), 0);
	rb_define_singleton_method(Editor, "DirectTagJump", reinterpret_cast<VALUE(__cdecl *)(...)>(S_DirectTagJump), 0);
	rb_define_singleton_method(Editor, "KeywordTagJump", reinterpret_cast<VALUE(__cdecl *)(...)>(S_KeywordTagJump), 1);
	rb_define_singleton_method(Editor, "Compare", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Compare), 0);
	rb_define_singleton_method(Editor, "DiffDialog", reinterpret_cast<VALUE(__cdecl *)(...)>(S_DiffDialog), 0);
	rb_define_singleton_method(Editor, "Diff", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Diff), 2);
	rb_define_singleton_method(Editor, "DiffNext", reinterpret_cast<VALUE(__cdecl *)(...)>(S_DiffNext), 0);
	rb_define_singleton_method(Editor, "DiffPrev", reinterpret_cast<VALUE(__cdecl *)(...)>(S_DiffPrev), 0);
	rb_define_singleton_method(Editor, "DiffReset", reinterpret_cast<VALUE(__cdecl *)(...)>(S_DiffReset), 0);
	rb_define_singleton_method(Editor, "BracketPair", reinterpret_cast<VALUE(__cdecl *)(...)>(S_BracketPair), 0);
	rb_define_singleton_method(Editor, "BookmarkSet", reinterpret_cast<VALUE(__cdecl *)(...)>(S_BookmarkSet), 0);
	rb_define_singleton_method(Editor, "BookmarkNext", reinterpret_cast<VALUE(__cdecl *)(...)>(S_BookmarkNext), 0);
	rb_define_singleton_method(Editor, "BookmarkPrev", reinterpret_cast<VALUE(__cdecl *)(...)>(S_BookmarkPrev), 0);
	rb_define_singleton_method(Editor, "BookmarkReset", reinterpret_cast<VALUE(__cdecl *)(...)>(S_BookmarkReset), 0);
	rb_define_singleton_method(Editor, "BookmarkView", reinterpret_cast<VALUE(__cdecl *)(...)>(S_BookmarkView), 0);
	rb_define_singleton_method(Editor, "BookmarkPattern", reinterpret_cast<VALUE(__cdecl *)(...)>(S_BookmarkPattern), 2);
	rb_define_singleton_method(Editor, "ChgmodINS", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ChgmodINS), 0);
	rb_define_singleton_method(Editor, "ChgCharSet", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ChgCharSet), 2);
	rb_define_singleton_method(Editor, "ChgmodEOL", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ChgmodEOL), 1);
	rb_define_singleton_method(Editor, "CancelMode", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CancelMode), 0);
	rb_define_singleton_method(Editor, "ExecExternalMacro", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ExecExternalMacro), 2);
	rb_define_singleton_method(Editor, "ShowToolbar", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ShowToolbar), 0);
	rb_define_singleton_method(Editor, "ShowFunckey", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ShowFunckey), 0);
	rb_define_singleton_method(Editor, "ShowTab", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ShowTab), 0);
	rb_define_singleton_method(Editor, "ShowStatusbar", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ShowStatusbar), 0);
	rb_define_singleton_method(Editor, "TypeList", reinterpret_cast<VALUE(__cdecl *)(...)>(S_TypeList), 0);
	rb_define_singleton_method(Editor, "ChangeType", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ChangeType), 1);
	rb_define_singleton_method(Editor, "OptionType", reinterpret_cast<VALUE(__cdecl *)(...)>(S_OptionType), 0);
	rb_define_singleton_method(Editor, "OptionCommon", reinterpret_cast<VALUE(__cdecl *)(...)>(S_OptionCommon), 0);
	rb_define_singleton_method(Editor, "SelectFont", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SelectFont), 0);
	rb_define_singleton_method(Editor, "SetFontSize", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SetFontSize), 3);
	rb_define_singleton_method(Editor, "WrapWindowWidth", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WrapWindowWidth), 0);
	rb_define_singleton_method(Editor, "OptionFavorite", reinterpret_cast<VALUE(__cdecl *)(...)>(S_OptionFavorite), 0);
	rb_define_singleton_method(Editor, "SetMsgQuoteStr", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SetMsgQuoteStr), 1);
	rb_define_singleton_method(Editor, "TextWrapMethod", reinterpret_cast<VALUE(__cdecl *)(...)>(S_TextWrapMethod), 1);
	rb_define_singleton_method(Editor, "SelectCountMode", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SelectCountMode), 1);
	rb_define_singleton_method(Editor, "ExecCommand", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ExecCommand), 3);
	rb_define_singleton_method(Editor, "ExecCommandDialog", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ExecCommandDialog), 0);
	rb_define_singleton_method(Editor, "RMenu", reinterpret_cast<VALUE(__cdecl *)(...)>(S_RMenu), 0);
	rb_define_singleton_method(Editor, "CustMenu1", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu1), 0);
	rb_define_singleton_method(Editor, "CustMenu2", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu2), 0);
	rb_define_singleton_method(Editor, "CustMenu3", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu3), 0);
	rb_define_singleton_method(Editor, "CustMenu4", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu4), 0);
	rb_define_singleton_method(Editor, "CustMenu5", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu5), 0);
	rb_define_singleton_method(Editor, "CustMenu6", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu6), 0);
	rb_define_singleton_method(Editor, "CustMenu7", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu7), 0);
	rb_define_singleton_method(Editor, "CustMenu8", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu8), 0);
	rb_define_singleton_method(Editor, "CustMenu9", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu9), 0);
	rb_define_singleton_method(Editor, "CustMenu10", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu10), 0);
	rb_define_singleton_method(Editor, "CustMenu11", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu11), 0);
	rb_define_singleton_method(Editor, "CustMenu12", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu12), 0);
	rb_define_singleton_method(Editor, "CustMenu13", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu13), 0);
	rb_define_singleton_method(Editor, "CustMenu14", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu14), 0);
	rb_define_singleton_method(Editor, "CustMenu15", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu15), 0);
	rb_define_singleton_method(Editor, "CustMenu16", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu16), 0);
	rb_define_singleton_method(Editor, "CustMenu17", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu17), 0);
	rb_define_singleton_method(Editor, "CustMenu18", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu18), 0);
	rb_define_singleton_method(Editor, "CustMenu19", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu19), 0);
	rb_define_singleton_method(Editor, "CustMenu20", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu20), 0);
	rb_define_singleton_method(Editor, "CustMenu21", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu21), 0);
	rb_define_singleton_method(Editor, "CustMenu22", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu22), 0);
	rb_define_singleton_method(Editor, "CustMenu23", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu23), 0);
	rb_define_singleton_method(Editor, "CustMenu24", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CustMenu24), 0);
	rb_define_singleton_method(Editor, "SplitWinV", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SplitWinV), 0);
	rb_define_singleton_method(Editor, "SplitWinH", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SplitWinH), 0);
	rb_define_singleton_method(Editor, "SplitWinVH", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SplitWinVH), 0);
	rb_define_singleton_method(Editor, "WinClose", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WinClose), 0);
	rb_define_singleton_method(Editor, "WinCloseAll", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WinCloseAll), 0);
	rb_define_singleton_method(Editor, "CascadeWin", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CascadeWin), 0);
	rb_define_singleton_method(Editor, "TileWinV", reinterpret_cast<VALUE(__cdecl *)(...)>(S_TileWinV), 0);
	rb_define_singleton_method(Editor, "TileWinH", reinterpret_cast<VALUE(__cdecl *)(...)>(S_TileWinH), 0);
	rb_define_singleton_method(Editor, "NextWindow", reinterpret_cast<VALUE(__cdecl *)(...)>(S_NextWindow), 0);
	rb_define_singleton_method(Editor, "PrevWindow", reinterpret_cast<VALUE(__cdecl *)(...)>(S_PrevWindow), 0);
	rb_define_singleton_method(Editor, "WindowList", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WindowList), 0);
	rb_define_singleton_method(Editor, "MaximizeV", reinterpret_cast<VALUE(__cdecl *)(...)>(S_MaximizeV), 0);
	rb_define_singleton_method(Editor, "MaximizeH", reinterpret_cast<VALUE(__cdecl *)(...)>(S_MaximizeH), 0);
	rb_define_singleton_method(Editor, "MinimizeAll", reinterpret_cast<VALUE(__cdecl *)(...)>(S_MinimizeAll), 0);
	rb_define_singleton_method(Editor, "ReDraw", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ReDraw), 0);
	rb_define_singleton_method(Editor, "ActivateWinOutput", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ActivateWinOutput), 0);
	rb_define_singleton_method(Editor, "TraceOut", reinterpret_cast<VALUE(__cdecl *)(...)>(S_TraceOut), 2);
	rb_define_singleton_method(Editor, "WindowTopMost", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WindowTopMost), 1);
	rb_define_singleton_method(Editor, "GroupClose", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GroupClose), 0);
	rb_define_singleton_method(Editor, "NextGroup", reinterpret_cast<VALUE(__cdecl *)(...)>(S_NextGroup), 0);
	rb_define_singleton_method(Editor, "PrevGroup", reinterpret_cast<VALUE(__cdecl *)(...)>(S_PrevGroup), 0);
	rb_define_singleton_method(Editor, "TabMoveRight", reinterpret_cast<VALUE(__cdecl *)(...)>(S_TabMoveRight), 0);
	rb_define_singleton_method(Editor, "TabMoveLeft", reinterpret_cast<VALUE(__cdecl *)(...)>(S_TabMoveLeft), 0);
	rb_define_singleton_method(Editor, "TabSeparate", reinterpret_cast<VALUE(__cdecl *)(...)>(S_TabSeparate), 0);
	rb_define_singleton_method(Editor, "TabJointNext", reinterpret_cast<VALUE(__cdecl *)(...)>(S_TabJointNext), 0);
	rb_define_singleton_method(Editor, "TabJointPrev", reinterpret_cast<VALUE(__cdecl *)(...)>(S_TabJointPrev), 0);
	rb_define_singleton_method(Editor, "TabCloseOther", reinterpret_cast<VALUE(__cdecl *)(...)>(S_TabCloseOther), 0);
	rb_define_singleton_method(Editor, "TabCloseLeft", reinterpret_cast<VALUE(__cdecl *)(...)>(S_TabCloseLeft), 0);
	rb_define_singleton_method(Editor, "TabCloseRight", reinterpret_cast<VALUE(__cdecl *)(...)>(S_TabCloseRight), 0);
	rb_define_singleton_method(Editor, "Complete", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Complete), 0);
	rb_define_singleton_method(Editor, "ToggleKeyHelpSearch", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ToggleKeyHelpSearch), 1);
	rb_define_singleton_method(Editor, "HelpContents", reinterpret_cast<VALUE(__cdecl *)(...)>(S_HelpContents), 0);
	rb_define_singleton_method(Editor, "HelpSearch", reinterpret_cast<VALUE(__cdecl *)(...)>(S_HelpSearch), 0);
	rb_define_singleton_method(Editor, "CommandList", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CommandList), 0);
	rb_define_singleton_method(Editor, "ExtHelp1", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ExtHelp1), 0);
	rb_define_singleton_method(Editor, "ExtHtmlHelp", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ExtHtmlHelp), 2);
	rb_define_singleton_method(Editor, "About", reinterpret_cast<VALUE(__cdecl *)(...)>(S_About), 0);
	rb_define_singleton_method(Editor, "StatusMsg", reinterpret_cast<VALUE(__cdecl *)(...)>(S_StatusMsg), 2);
	rb_define_singleton_method(Editor, "MsgBeep", reinterpret_cast<VALUE(__cdecl *)(...)>(S_MsgBeep), 1);
	rb_define_singleton_method(Editor, "CommitUndoBuffer", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CommitUndoBuffer), 0);
	rb_define_singleton_method(Editor, "AddRefUndoBuffer", reinterpret_cast<VALUE(__cdecl *)(...)>(S_AddRefUndoBuffer), 0);
	rb_define_singleton_method(Editor, "SetUndoBuffer", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SetUndoBuffer), 0);
	rb_define_singleton_method(Editor, "AppendUndoBufferCursor", reinterpret_cast<VALUE(__cdecl *)(...)>(S_AppendUndoBufferCursor), 0);
	rb_define_singleton_method(Editor, "ClipboardEmpty", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ClipboardEmpty), 0);

	//Functions
	rb_define_singleton_method(Editor, "GetFilename", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetFilename), 0);
	rb_define_singleton_method(Editor, "GetSaveFilename", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetSaveFilename), 0);
	rb_define_singleton_method(Editor, "GetSelectedString", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetSelectedString), 1);
	rb_define_singleton_method(Editor, "ExpandParameter", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ExpandParameter), 1);
	rb_define_singleton_method(Editor, "GetLineStr", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetLineStr), 1);
	rb_define_singleton_method(Editor, "GetLineCount", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetLineCount), 1);
	rb_define_singleton_method(Editor, "ChangeTabWidth", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ChangeTabWidth), 1);
	rb_define_singleton_method(Editor, "IsTextSelected", reinterpret_cast<VALUE(__cdecl *)(...)>(S_IsTextSelected), 0);
	rb_define_singleton_method(Editor, "GetSelectLineFrom", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetSelectLineFrom), 0);
	rb_define_singleton_method(Editor, "GetSelectColmFrom", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetSelectColmFrom), 0);
	rb_define_singleton_method(Editor, "GetSelectColumnFrom", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetSelectColumnFrom), 0);
	rb_define_singleton_method(Editor, "GetSelectLineTo", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetSelectLineTo), 0);
	rb_define_singleton_method(Editor, "GetSelectColmTo", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetSelectColmTo), 0);
	rb_define_singleton_method(Editor, "GetSelectColumnTo", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetSelectColumnTo), 0);
	rb_define_singleton_method(Editor, "IsInsMode", reinterpret_cast<VALUE(__cdecl *)(...)>(S_IsInsMode), 0);
	rb_define_singleton_method(Editor, "GetCharCode", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetCharCode), 0);
	rb_define_singleton_method(Editor, "GetLineCode", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetLineCode), 0);
	rb_define_singleton_method(Editor, "IsPossibleUndo", reinterpret_cast<VALUE(__cdecl *)(...)>(S_IsPossibleUndo), 0);
	rb_define_singleton_method(Editor, "IsPossibleRedo", reinterpret_cast<VALUE(__cdecl *)(...)>(S_IsPossibleRedo), 0);
	rb_define_singleton_method(Editor, "ChangeWrapColm", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ChangeWrapColm), 1);
	rb_define_singleton_method(Editor, "ChangeWrapColumn", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ChangeWrapColumn), 1);
	rb_define_singleton_method(Editor, "IsCurTypeExt", reinterpret_cast<VALUE(__cdecl *)(...)>(S_IsCurTypeExt), 1);
	rb_define_singleton_method(Editor, "IsSameTypeExt", reinterpret_cast<VALUE(__cdecl *)(...)>(S_IsSameTypeExt), 2);
	rb_define_singleton_method(Editor, "InputBox", reinterpret_cast<VALUE(__cdecl *)(...)>(S_InputBox), 3);
	rb_define_singleton_method(Editor, "MessageBox", reinterpret_cast<VALUE(__cdecl *)(...)>(S_MessageBox), 2);
	rb_define_singleton_method(Editor, "ErrorMsg", reinterpret_cast<VALUE(__cdecl *)(...)>(S_ErrorMsg), 1);
	rb_define_singleton_method(Editor, "WarnMsg", reinterpret_cast<VALUE(__cdecl *)(...)>(S_WarnMsg), 1);
	rb_define_singleton_method(Editor, "InfoMsg", reinterpret_cast<VALUE(__cdecl *)(...)>(S_InfoMsg), 1);
	rb_define_singleton_method(Editor, "OkCancelBox", reinterpret_cast<VALUE(__cdecl *)(...)>(S_OkCancelBox), 1);
	rb_define_singleton_method(Editor, "YesNoBox", reinterpret_cast<VALUE(__cdecl *)(...)>(S_YesNoBox), 1);
	rb_define_singleton_method(Editor, "CompareVersion", reinterpret_cast<VALUE(__cdecl *)(...)>(S_CompareVersion), 2);
	rb_define_singleton_method(Editor, "Sleep", reinterpret_cast<VALUE(__cdecl *)(...)>(S_Sleep), 1);
	rb_define_singleton_method(Editor, "FileOpenDialog", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileOpenDialog), 2);
	rb_define_singleton_method(Editor, "FileSaveDialog", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FileSaveDialog), 2);
	rb_define_singleton_method(Editor, "FolderDialog", reinterpret_cast<VALUE(__cdecl *)(...)>(S_FolderDialog), 2);
	rb_define_singleton_method(Editor, "GetClipboard", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetClipboard), 1);
	rb_define_singleton_method(Editor, "SetClipboard", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SetClipboard), 2);
	rb_define_singleton_method(Editor, "LayoutToLogicLineNum", reinterpret_cast<VALUE(__cdecl *)(...)>(S_LayoutToLogicLineNum), 1);
	rb_define_singleton_method(Editor, "LogicToLayoutLineNum", reinterpret_cast<VALUE(__cdecl *)(...)>(S_LogicToLayoutLineNum), 2);
	rb_define_singleton_method(Editor, "LineColumnToIndex", reinterpret_cast<VALUE(__cdecl *)(...)>(S_LineColumnToIndex), 2);
	rb_define_singleton_method(Editor, "LineIndexToColumn", reinterpret_cast<VALUE(__cdecl *)(...)>(S_LineIndexToColumn), 2);
	rb_define_singleton_method(Editor, "GetCookie", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetCookie), 2);
	rb_define_singleton_method(Editor, "GetCookieDefault", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetCookieDefault), 3);
	rb_define_singleton_method(Editor, "SetCookie", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SetCookie), 3);
	rb_define_singleton_method(Editor, "DeleteCookie", reinterpret_cast<VALUE(__cdecl *)(...)>(S_DeleteCookie), 2);
	rb_define_singleton_method(Editor, "GetCookieNames", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetCookieNames), 1);
	rb_define_singleton_method(Editor, "SetDrawSwitch", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SetDrawSwitch), 1);
	rb_define_singleton_method(Editor, "GetDrawSwitch", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetDrawSwitch), 0);
	rb_define_singleton_method(Editor, "IsShownStatus", reinterpret_cast<VALUE(__cdecl *)(...)>(S_IsShownStatus), 0);
	rb_define_singleton_method(Editor, "GetStrWidth", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetStrWidth), 2);
	rb_define_singleton_method(Editor, "GetStrLayoutLength", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetStrLayoutLength), 2);
	rb_define_singleton_method(Editor, "GetDefaultCharLength", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetDefaultCharLength), 0);
	rb_define_singleton_method(Editor, "IsIncludeClipboardFormat", reinterpret_cast<VALUE(__cdecl *)(...)>(S_IsIncludeClipboardFormat), 1);
	rb_define_singleton_method(Editor, "GetClipboardByFormat", reinterpret_cast<VALUE(__cdecl *)(...)>(S_GetClipboardByFormat), 3);
	rb_define_singleton_method(Editor, "SetClipboardByFormat", reinterpret_cast<VALUE(__cdecl *)(...)>(S_SetClipboardByFormat), 4);
}

VALUE __cdecl CRuby::S_FileNew(VALUE self){
	return CommandHandler(F_FILENEW, NULL, 0);
}

VALUE __cdecl CRuby::S_FileOpen(VALUE self, VALUE arg1, VALUE arg2, VALUE arg3, VALUE arg4){
	VALUE args[4] = { arg1, arg2, arg3, arg4 };
	return CommandHandler(F_FILEOPEN2, args, 4);
}

VALUE __cdecl CRuby::S_FileSave(VALUE self){
	return CommandHandler(F_FILESAVE, NULL, 0);
}

VALUE __cdecl CRuby::S_FileSaveAll(VALUE self){
	return CommandHandler(F_FILESAVEALL, NULL, 0);
}

VALUE __cdecl CRuby::S_FileSaveAsDialog(VALUE self, VALUE arg1, VALUE arg2, VALUE arg3){
	VALUE args[3] = { arg1, arg2, arg3 };
	return CommandHandler(F_FILESAVEAS_DIALOG, args, 3);
}

VALUE __cdecl CRuby::S_FileSaveAs(VALUE self, VALUE arg1, VALUE arg2, VALUE arg3){
	VALUE args[3] = { arg1, arg2, arg3 };
	return CommandHandler(F_FILESAVEAS, args, 3);
}

VALUE __cdecl CRuby::S_FileClose(VALUE self){
	return CommandHandler(F_FILECLOSE, NULL, 0);
}

VALUE __cdecl CRuby::S_FileCloseOpen(VALUE self){
	return CommandHandler(F_FILECLOSE_OPEN, NULL, 0);
}

VALUE __cdecl CRuby::S_FileReopen(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_FILE_REOPEN, args, 1);
}

VALUE __cdecl CRuby::S_FileReopenSJIS(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_FILE_REOPEN_SJIS, args, 1);
}

VALUE __cdecl CRuby::S_FileReopenJIS(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_FILE_REOPEN_JIS, args, 1);
}

VALUE __cdecl CRuby::S_FileReopenEUC(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_FILE_REOPEN_EUC, args, 1);
}

VALUE __cdecl CRuby::S_FileReopenLatin1(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_FILE_REOPEN_LATIN1, args, 1);
}

VALUE __cdecl CRuby::S_FileReopenUNICODE(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_FILE_REOPEN_UNICODE, args, 1);
}

VALUE __cdecl CRuby::S_FileReopenUNICODEBE(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_FILE_REOPEN_UNICODEBE, args, 1);
}

VALUE __cdecl CRuby::S_FileReopenUTF8(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_FILE_REOPEN_UTF8, args, 1);
}

VALUE __cdecl CRuby::S_FileReopenCESU8(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_FILE_REOPEN_CESU8, args, 1);
}

VALUE __cdecl CRuby::S_FileReopenUTF7(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_FILE_REOPEN_UTF7, args, 1);
}

VALUE __cdecl CRuby::S_Print(VALUE self){
	return CommandHandler(F_PRINT, NULL, 0);
}

VALUE __cdecl CRuby::S_PrintPreview(VALUE self){
	return CommandHandler(F_PRINT_PREVIEW, NULL, 0);
}

VALUE __cdecl CRuby::S_PrintPageSetup(VALUE self){
	return CommandHandler(F_PRINT_PAGESETUP, NULL, 0);
}

VALUE __cdecl CRuby::S_OpenHfromtoC(VALUE self){
	return CommandHandler(F_OPEN_HfromtoC, NULL, 0);
}

VALUE __cdecl CRuby::S_ActivateSQLPLUS(VALUE self){
	return CommandHandler(F_ACTIVATE_SQLPLUS, NULL, 0);
}

VALUE __cdecl CRuby::S_ExecSQLPLUS(VALUE self){
	return CommandHandler(F_PLSQL_COMPILE_ON_SQLPLUS, NULL, 0);
}

VALUE __cdecl CRuby::S_Browse(VALUE self){
	return CommandHandler(F_BROWSE, NULL, 0);
}

VALUE __cdecl CRuby::S_ViewMode(VALUE self){
	return CommandHandler(F_VIEWMODE, NULL, 0);
}

VALUE __cdecl CRuby::S_ReadOnly(VALUE self){
	return CommandHandler(F_VIEWMODE, NULL, 0);
}

VALUE __cdecl CRuby::S_PropertyFile(VALUE self){
	return CommandHandler(F_PROPERTY_FILE, NULL, 0);
}

VALUE __cdecl CRuby::S_ExitAllEditors(VALUE self){
	return CommandHandler(F_EXITALLEDITORS, NULL, 0);
}

VALUE __cdecl CRuby::S_ExitAll(VALUE self){
	return CommandHandler(F_EXITALL, NULL, 0);
}

VALUE __cdecl CRuby::S_PutFile(VALUE self, VALUE arg1, VALUE arg2, VALUE arg3){
	VALUE args[3] = { arg1, arg2, arg3 };
	return CommandHandler(F_PUTFILE, args, 3);
}

VALUE __cdecl CRuby::S_InsFile(VALUE self, VALUE arg1, VALUE arg2, VALUE arg3){
	VALUE args[3] = { arg1, arg2, arg3 };
	return CommandHandler(F_INSFILE, args, 3);
}

VALUE __cdecl CRuby::S_Char(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_WCHAR, args, 1);
}

VALUE __cdecl CRuby::S_CharIme(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_IME_CHAR, args, 1);
}

VALUE __cdecl CRuby::S_Undo(VALUE self){
	return CommandHandler(F_UNDO, NULL, 0);
}

VALUE __cdecl CRuby::S_Redo(VALUE self){
	return CommandHandler(F_REDO, NULL, 0);
}

VALUE __cdecl CRuby::S_Delete(VALUE self){
	return CommandHandler(F_DELETE, NULL, 0);
}

VALUE __cdecl CRuby::S_DeleteBack(VALUE self){
	return CommandHandler(F_DELETE_BACK, NULL, 0);
}

VALUE __cdecl CRuby::S_WordDeleteToStart(VALUE self){
	return CommandHandler(F_WordDeleteToStart, NULL, 0);
}

VALUE __cdecl CRuby::S_WordDeleteToEnd(VALUE self){
	return CommandHandler(F_WordDeleteToEnd, NULL, 0);
}

VALUE __cdecl CRuby::S_WordCut(VALUE self){
	return CommandHandler(F_WordCut, NULL, 0);
}

VALUE __cdecl CRuby::S_WordDelete(VALUE self){
	return CommandHandler(F_WordDelete, NULL, 0);
}

VALUE __cdecl CRuby::S_LineCutToStart(VALUE self){
	return CommandHandler(F_LineCutToStart, NULL, 0);
}

VALUE __cdecl CRuby::S_LineCutToEnd(VALUE self){
	return CommandHandler(F_LineCutToEnd, NULL, 0);
}

VALUE __cdecl CRuby::S_LineDeleteToStart(VALUE self){
	return CommandHandler(F_LineDeleteToStart, NULL, 0);
}

VALUE __cdecl CRuby::S_LineDeleteToEnd(VALUE self){
	return CommandHandler(F_LineDeleteToEnd, NULL, 0);
}

VALUE __cdecl CRuby::S_CutLine(VALUE self){
	return CommandHandler(F_CUT_LINE, NULL, 0);
}

VALUE __cdecl CRuby::S_DeleteLine(VALUE self){
	return CommandHandler(F_DELETE_LINE, NULL, 0);
}

VALUE __cdecl CRuby::S_DuplicateLine(VALUE self){
	return CommandHandler(F_DUPLICATELINE, NULL, 0);
}

VALUE __cdecl CRuby::S_IndentTab(VALUE self){
	return CommandHandler(F_INDENT_TAB, NULL, 0);
}

VALUE __cdecl CRuby::S_UnindentTab(VALUE self){
	return CommandHandler(F_UNINDENT_TAB, NULL, 0);
}

VALUE __cdecl CRuby::S_IndentSpace(VALUE self){
	return CommandHandler(F_INDENT_SPACE, NULL, 0);
}

VALUE __cdecl CRuby::S_UnindentSpace(VALUE self){
	return CommandHandler(F_UNINDENT_SPACE, NULL, 0);
}

VALUE __cdecl CRuby::S_LTrim(VALUE self){
	return CommandHandler(F_LTRIM, NULL, 0);
}

VALUE __cdecl CRuby::S_RTrim(VALUE self){
	return CommandHandler(F_RTRIM, NULL, 0);
}

VALUE __cdecl CRuby::S_SortAsc(VALUE self){
	return CommandHandler(F_SORT_ASC, NULL, 0);
}

VALUE __cdecl CRuby::S_SortDesc(VALUE self){
	return CommandHandler(F_SORT_DESC, NULL, 0);
}

VALUE __cdecl CRuby::S_Merge(VALUE self){
	return CommandHandler(F_MERGE, NULL, 0);
}

VALUE __cdecl CRuby::S_Up(VALUE self){
	return CommandHandler(F_UP, NULL, 0);
}

VALUE __cdecl CRuby::S_Down(VALUE self){
	return CommandHandler(F_DOWN, NULL, 0);
}

VALUE __cdecl CRuby::S_Left(VALUE self){
	return CommandHandler(F_LEFT, NULL, 0);
}

VALUE __cdecl CRuby::S_Right(VALUE self){
	return CommandHandler(F_RIGHT, NULL, 0);
}

VALUE __cdecl CRuby::S_Up2(VALUE self){
	return CommandHandler(F_UP2, NULL, 0);
}

VALUE __cdecl CRuby::S_Down2(VALUE self){
	return CommandHandler(F_DOWN2, NULL, 0);
}

VALUE __cdecl CRuby::S_WordLeft(VALUE self){
	return CommandHandler(F_WORDLEFT, NULL, 0);
}

VALUE __cdecl CRuby::S_WordRight(VALUE self){
	return CommandHandler(F_WORDRIGHT, NULL, 0);
}

VALUE __cdecl CRuby::S_GoLineTop(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_GOLINETOP, args, 1);
}

VALUE __cdecl CRuby::S_GoLineEnd(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_GOLINEEND, args, 1);
}

VALUE __cdecl CRuby::S_HalfPageUp(VALUE self){
	return CommandHandler(F_HalfPageUp, NULL, 0);
}

VALUE __cdecl CRuby::S_HalfPageDown(VALUE self){
	return CommandHandler(F_HalfPageDown, NULL, 0);
}

VALUE __cdecl CRuby::S_PageUp(VALUE self){
	return CommandHandler(F_1PageUp, NULL, 0);
}

VALUE __cdecl CRuby::S_1PageUp(VALUE self){
	return CommandHandler(F_1PageUp, NULL, 0);
}

VALUE __cdecl CRuby::S_PageDown(VALUE self){
	return CommandHandler(F_1PageDown, NULL, 0);
}

VALUE __cdecl CRuby::S_1PageDown(VALUE self){
	return CommandHandler(F_1PageDown, NULL, 0);
}

VALUE __cdecl CRuby::S_GoFileTop(VALUE self){
	return CommandHandler(F_GOFILETOP, NULL, 0);
}

VALUE __cdecl CRuby::S_GoFileEnd(VALUE self){
	return CommandHandler(F_GOFILEEND, NULL, 0);
}

VALUE __cdecl CRuby::S_CurLineCenter(VALUE self){
	return CommandHandler(F_CURLINECENTER, NULL, 0);
}

VALUE __cdecl CRuby::S_MoveHistPrev(VALUE self){
	return CommandHandler(F_JUMPHIST_PREV, NULL, 0);
}

VALUE __cdecl CRuby::S_MoveHistNext(VALUE self){
	return CommandHandler(F_JUMPHIST_NEXT, NULL, 0);
}

VALUE __cdecl CRuby::S_MoveHistSet(VALUE self){
	return CommandHandler(F_JUMPHIST_SET, NULL, 0);
}

VALUE __cdecl CRuby::S_F_WndScrollDown(VALUE self){
	return CommandHandler(F_WndScrollDown, NULL, 0);
}

VALUE __cdecl CRuby::S_F_WndScrollUp(VALUE self){
	return CommandHandler(F_WndScrollUp, NULL, 0);
}

VALUE __cdecl CRuby::S_GoNextParagraph(VALUE self){
	return CommandHandler(F_GONEXTPARAGRAPH, NULL, 0);
}

VALUE __cdecl CRuby::S_GoPrevParagraph(VALUE self){
	return CommandHandler(F_GOPREVPARAGRAPH, NULL, 0);
}

VALUE __cdecl CRuby::S_MoveCursor(VALUE self, VALUE arg1, VALUE arg2, VALUE arg3){
	VALUE args[3] = { arg1, arg2, arg3 };
	return CommandHandler(F_MOVECURSOR, args, 3);
}

VALUE __cdecl CRuby::S_MoveCursorLayout(VALUE self, VALUE arg1, VALUE arg2, VALUE arg3){
	VALUE args[3] = { arg1, arg2, arg3 };
	return CommandHandler(F_MOVECURSORLAYOUT, args, 3);
}

VALUE __cdecl CRuby::S_WhellUp(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_WHELL_FIRST, args, 1);
}

VALUE __cdecl CRuby::S_WhellDown(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_WHELLDOWN, args, 1);
}

VALUE __cdecl CRuby::S_WhellLeft(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_WHELLLEFT, args, 1);
}

VALUE __cdecl CRuby::S_WhellRight(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_WHELLRIGHT, args, 1);
}

VALUE __cdecl CRuby::S_WhellPageUp(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_WHELLPAGEUP, args, 1);
}

VALUE __cdecl CRuby::S_WhellPageDown(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_WHELLPAGEDOWN, args, 1);
}

VALUE __cdecl CRuby::S_WhellPageLeft(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_WHELLPAGELEFT, args, 1);
}

VALUE __cdecl CRuby::S_WhellPageRight(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_WHELLPAGERIGHT, args, 1);
}

VALUE __cdecl CRuby::S_SelectWord(VALUE self){
	return CommandHandler(F_SELECTWORD, NULL, 0);
}

VALUE __cdecl CRuby::S_SelectAll(VALUE self){
	return CommandHandler(F_SELECTALL, NULL, 0);
}

VALUE __cdecl CRuby::S_SelectLine(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_SELECTLINE, args, 1);
}

VALUE __cdecl CRuby::S_BeginSelect(VALUE self){
	return CommandHandler(F_BEGIN_SEL, NULL, 0);
}

VALUE __cdecl CRuby::S_Up_Sel(VALUE self){
	return CommandHandler(F_UP_SEL, NULL, 0);
}

VALUE __cdecl CRuby::S_Down_Sel(VALUE self){
	return CommandHandler(F_DOWN_SEL, NULL, 0);
}

VALUE __cdecl CRuby::S_Left_Sel(VALUE self){
	return CommandHandler(F_LEFT_SEL, NULL, 0);
}

VALUE __cdecl CRuby::S_Right_Sel(VALUE self){
	return CommandHandler(F_RIGHT_SEL, NULL, 0);
}

VALUE __cdecl CRuby::S_Up2_Sel(VALUE self){
	return CommandHandler(F_UP2_SEL, NULL, 0);
}

VALUE __cdecl CRuby::S_Down2_Sel(VALUE self){
	return CommandHandler(F_DOWN2_SEL, NULL, 0);
}

VALUE __cdecl CRuby::S_WordLeft_Sel(VALUE self){
	return CommandHandler(F_WORDLEFT_SEL, NULL, 0);
}

VALUE __cdecl CRuby::S_WordRight_Sel(VALUE self){
	return CommandHandler(F_WORDRIGHT_SEL, NULL, 0);
}

VALUE __cdecl CRuby::S_GoLineTop_Sel(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_GOLINETOP_SEL, args, 1);
}

VALUE __cdecl CRuby::S_GoLineEnd_Sel(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_GOLINEEND_SEL, args, 1);
}

VALUE __cdecl CRuby::S_HalfPageUp_Sel(VALUE self){
	return CommandHandler(F_HalfPageUp_Sel, NULL, 0);
}

VALUE __cdecl CRuby::S_HalfPageDown_Sel(VALUE self){
	return CommandHandler(F_HalfPageDown_Sel, NULL, 0);
}

VALUE __cdecl CRuby::S_PageUp_Sel(VALUE self){
	return CommandHandler(F_1PageUp_Sel, NULL, 0);
}

VALUE __cdecl CRuby::S_1PageUp_Sel(VALUE self){
	return CommandHandler(F_1PageUp_Sel, NULL, 0);
}

VALUE __cdecl CRuby::S_PageDown_Sel(VALUE self){
	return CommandHandler(F_1PageDown_Sel, NULL, 0);
}

VALUE __cdecl CRuby::S_1PageDown_Sel(VALUE self){
	return CommandHandler(F_1PageDown_Sel, NULL, 0);
}

VALUE __cdecl CRuby::S_GoFileTop_Sel(VALUE self){
	return CommandHandler(F_GOFILETOP_SEL, NULL, 0);
}

VALUE __cdecl CRuby::S_GoFileEnd_Sel(VALUE self){
	return CommandHandler(F_GOFILEEND_SEL, NULL, 0);
}

VALUE __cdecl CRuby::S_GoNextParagraph_Sel(VALUE self){
	return CommandHandler(F_GONEXTPARAGRAPH_SEL, NULL, 0);
}

VALUE __cdecl CRuby::S_GoPrevParagraph_Sel(VALUE self){
	return CommandHandler(F_GOPREVPARAGRAPH_SEL, NULL, 0);
}

VALUE __cdecl CRuby::S_BeginBoxSelect(VALUE self){
	return CommandHandler(F_BEGIN_BOX, NULL, 0);
}

VALUE __cdecl CRuby::S_Up_BoxSel(VALUE self){
	return CommandHandler(F_UP_BOX, NULL, 0);
}

VALUE __cdecl CRuby::S_Down_BoxSel(VALUE self){
	return CommandHandler(F_DOWN_BOX, NULL, 0);
}

VALUE __cdecl CRuby::S_Left_BoxSel(VALUE self){
	return CommandHandler(F_LEFT_BOX, NULL, 0);
}

VALUE __cdecl CRuby::S_Right_BoxSel(VALUE self){
	return CommandHandler(F_RIGHT_BOX, NULL, 0);
}

VALUE __cdecl CRuby::S_Up2_BoxSel(VALUE self){
	return CommandHandler(F_UP2_BOX, NULL, 0);
}

VALUE __cdecl CRuby::S_Down2_BoxSel(VALUE self){
	return CommandHandler(F_DOWN2_BOX, NULL, 0);
}

VALUE __cdecl CRuby::S_WordLeft_BoxSel(VALUE self){
	return CommandHandler(F_WORDLEFT_BOX, NULL, 0);
}

VALUE __cdecl CRuby::S_WordRight_BoxSel(VALUE self){
	return CommandHandler(F_WORDRIGHT_BOX, NULL, 0);
}

VALUE __cdecl CRuby::S_GoLogicalLineTop_BoxSel(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_GOLOGICALLINETOP_BOX, args, 1);
}

VALUE __cdecl CRuby::S_GoLineTop_BoxSel(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_GOLINETOP_BOX, args, 1);
}

VALUE __cdecl CRuby::S_GoLineEnd_BoxSel(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_GOLINEEND_BOX, args, 1);
}

VALUE __cdecl CRuby::S_HalfPageUp_BoxSel(VALUE self){
	return CommandHandler(F_HalfPageUp_BOX, NULL, 0);
}

VALUE __cdecl CRuby::S_HalfPageDown_BoxSel(VALUE self){
	return CommandHandler(F_HalfPageDown_BOX, NULL, 0);
}

VALUE __cdecl CRuby::S_PageUp_BoxSel(VALUE self){
	return CommandHandler(F_1PageUp_BOX, NULL, 0);
}

VALUE __cdecl CRuby::S_1PageUp_BoxSel(VALUE self){
	return CommandHandler(F_1PageUp_BOX, NULL, 0);
}

VALUE __cdecl CRuby::S_PageDown_BoxSel(VALUE self){
	return CommandHandler(F_1PageDown_BOX, NULL, 0);
}

VALUE __cdecl CRuby::S_1PageDown_BoxSel(VALUE self){
	return CommandHandler(F_1PageDown_BOX, NULL, 0);
}

VALUE __cdecl CRuby::S_GoFileTop_BoxSel(VALUE self){
	return CommandHandler(F_GOFILETOP_BOX, NULL, 0);
}

VALUE __cdecl CRuby::S_GoFileEnd_BoxSel(VALUE self){
	return CommandHandler(F_GOFILEEND_BOX, NULL, 0);
}

VALUE __cdecl CRuby::S_Cut(VALUE self){
	return CommandHandler(F_CUT, NULL, 0);
}

VALUE __cdecl CRuby::S_Copy(VALUE self){
	return CommandHandler(F_COPY, NULL, 0);
}

VALUE __cdecl CRuby::S_Paste(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_PASTE, args, 1);
}

VALUE __cdecl CRuby::S_CopyAddCRLF(VALUE self){
	return CommandHandler(F_COPY_ADDCRLF, NULL, 0);
}

VALUE __cdecl CRuby::S_CopyCRLF(VALUE self){
	return CommandHandler(F_COPY_CRLF, NULL, 0);
}

VALUE __cdecl CRuby::S_PasteBox(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_PASTEBOX, args, 1);
}

VALUE __cdecl CRuby::S_InsBoxText(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_INSBOXTEXT, args, 1);
}

VALUE __cdecl CRuby::S_InsText(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_INSTEXT_W, args, 1);
}

VALUE __cdecl CRuby::S_AddTail(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_ADDTAIL_W, args, 1);
}

VALUE __cdecl CRuby::S_CopyLines(VALUE self){
	return CommandHandler(F_COPYLINES, NULL, 0);
}

VALUE __cdecl CRuby::S_CopyLinesAsPassage(VALUE self){
	return CommandHandler(F_COPYLINESASPASSAGE, NULL, 0);
}

VALUE __cdecl CRuby::S_CopyLinesWithLineNumber(VALUE self){
	return CommandHandler(F_COPYLINESWITHLINENUMBER, NULL, 0);
}

VALUE __cdecl CRuby::S_CopyColorHtml(VALUE self){
	return CommandHandler(F_COPY_COLOR_HTML, NULL, 0);
}

VALUE __cdecl CRuby::S_CopyColorHtmlWithLineNumber(VALUE self){
	return CommandHandler(F_COPY_COLOR_HTML_LINENUMBER, NULL, 0);
}

VALUE __cdecl CRuby::S_CopyPath(VALUE self){
	return CommandHandler(F_COPYPATH, NULL, 0);
}

VALUE __cdecl CRuby::S_CopyFilename(VALUE self){
	return CommandHandler(F_COPYFNAME, NULL, 0);
}

VALUE __cdecl CRuby::S_CopyTag(VALUE self){
	return CommandHandler(F_COPYTAG, NULL, 0);
}

VALUE __cdecl CRuby::S_CopyKeyBindList(VALUE self){
	return CommandHandler(F_CREATEKEYBINDLIST, NULL, 0);
}

VALUE __cdecl CRuby::S_InsertDate(VALUE self){
	return CommandHandler(F_INS_DATE, NULL, 0);
}

VALUE __cdecl CRuby::S_InsertTime(VALUE self){
	return CommandHandler(F_INS_TIME, NULL, 0);
}

VALUE __cdecl CRuby::S_CtrlCodeDialog(VALUE self){
	return CommandHandler(F_CTRL_CODE_DIALOG, NULL, 0);
}

VALUE __cdecl CRuby::S_ToLower(VALUE self){
	return CommandHandler(F_TOLOWER, NULL, 0);
}

VALUE __cdecl CRuby::S_ToUpper(VALUE self){
	return CommandHandler(F_TOUPPER, NULL, 0);
}

VALUE __cdecl CRuby::S_ToHankaku(VALUE self){
	return CommandHandler(F_TOHANKAKU, NULL, 0);
}

VALUE __cdecl CRuby::S_ToHankata(VALUE self){
	return CommandHandler(F_TOHANKATA, NULL, 0);
}

VALUE __cdecl CRuby::S_ToZenEi(VALUE self){
	return CommandHandler(F_TOZENEI, NULL, 0);
}

VALUE __cdecl CRuby::S_ToHanEi(VALUE self){
	return CommandHandler(F_TOHANEI, NULL, 0);
}

VALUE __cdecl CRuby::S_ToZenKata(VALUE self){
	return CommandHandler(F_TOZENKAKUKATA, NULL, 0);
}

VALUE __cdecl CRuby::S_ToZenHira(VALUE self){
	return CommandHandler(F_TOZENKAKUHIRA, NULL, 0);
}

VALUE __cdecl CRuby::S_HanKataToZenKata(VALUE self){
	return CommandHandler(F_HANKATATOZENKATA, NULL, 0);
}

VALUE __cdecl CRuby::S_HanKataToZenHira(VALUE self){
	return CommandHandler(F_HANKATATOZENHIRA, NULL, 0);
}

VALUE __cdecl CRuby::S_TABToSPACE(VALUE self){
	return CommandHandler(F_TABTOSPACE, NULL, 0);
}

VALUE __cdecl CRuby::S_SPACEToTAB(VALUE self){
	return CommandHandler(F_SPACETOTAB, NULL, 0);
}

VALUE __cdecl CRuby::S_AutoToSJIS(VALUE self){
	return CommandHandler(F_CODECNV_AUTO2SJIS, NULL, 0);
}

VALUE __cdecl CRuby::S_JIStoSJIS(VALUE self){
	return CommandHandler(F_CODECNV_EMAIL, NULL, 0);
}

VALUE __cdecl CRuby::S_EUCtoSJIS(VALUE self){
	return CommandHandler(F_CODECNV_EUC2SJIS, NULL, 0);
}

VALUE __cdecl CRuby::S_CodeCnvUNICODEtoSJIS(VALUE self){
	return CommandHandler(F_CODECNV_UNICODE2SJIS, NULL, 0);
}

VALUE __cdecl CRuby::S_CodeCnvUNICODEBEtoSJIS(VALUE self){
	return CommandHandler(F_CODECNV_UNICODEBE2SJIS, NULL, 0);
}

VALUE __cdecl CRuby::S_UTF8toSJIS(VALUE self){
	return CommandHandler(F_CODECNV_UTF82SJIS, NULL, 0);
}

VALUE __cdecl CRuby::S_UTF7toSJIS(VALUE self){
	return CommandHandler(F_CODECNV_UTF72SJIS, NULL, 0);
}

VALUE __cdecl CRuby::S_SJIStoJIS(VALUE self){
	return CommandHandler(F_CODECNV_SJIS2JIS, NULL, 0);
}

VALUE __cdecl CRuby::S_SJIStoEUC(VALUE self){
	return CommandHandler(F_CODECNV_SJIS2EUC, NULL, 0);
}

VALUE __cdecl CRuby::S_SJIStoUTF8(VALUE self){
	return CommandHandler(F_CODECNV_SJIS2UTF8, NULL, 0);
}

VALUE __cdecl CRuby::S_SJIStoUTF7(VALUE self){
	return CommandHandler(F_CODECNV_SJIS2UTF7, NULL, 0);
}

VALUE __cdecl CRuby::S_Base64Decode(VALUE self){
	return CommandHandler(F_BASE64DECODE, NULL, 0);
}

VALUE __cdecl CRuby::S_Uudecode(VALUE self){
	return CommandHandler(F_UUDECODE, NULL, 0);
}

VALUE __cdecl CRuby::S_SearchDialog(VALUE self){
	return CommandHandler(F_SEARCH_DIALOG, NULL, 0);
}

VALUE __cdecl CRuby::S_SearchNext(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return CommandHandler(F_SEARCH_NEXT, args, 2);
}

VALUE __cdecl CRuby::S_SearchPrev(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return CommandHandler(F_SEARCH_PREV, args, 2);
}

VALUE __cdecl CRuby::S_ReplaceDialog(VALUE self){
	return CommandHandler(F_REPLACE_DIALOG, NULL, 0);
}

VALUE __cdecl CRuby::S_Replace(VALUE self, VALUE arg1, VALUE arg2, VALUE arg3){
	VALUE args[3] = { arg1, arg2, arg3 };
	return CommandHandler(F_REPLACE, args, 3);
}

VALUE __cdecl CRuby::S_ReplaceAll(VALUE self, VALUE arg1, VALUE arg2, VALUE arg3){
	VALUE args[3] = { arg1, arg2, arg3 };
	return CommandHandler(F_REPLACE_ALL, args, 3);
}

VALUE __cdecl CRuby::S_SearchClearMark(VALUE self){
	return CommandHandler(F_SEARCH_CLEARMARK, NULL, 0);
}

VALUE __cdecl CRuby::S_SearchStartPos(VALUE self){
	return CommandHandler(F_JUMP_SRCHSTARTPOS, NULL, 0);
}

VALUE __cdecl CRuby::S_Grep(VALUE self, VALUE arg1, VALUE arg2, VALUE arg3, VALUE arg4, VALUE arg5){
	VALUE args[5] = { arg1, arg2, arg3, arg4, arg5 };
	return CommandHandler(F_GREP, args, 5);
}

VALUE __cdecl CRuby::S_Jump(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return CommandHandler(F_JUMP, args, 2);
}

VALUE __cdecl CRuby::S_Outline(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_OUTLINE, args, 1);
}

VALUE __cdecl CRuby::S_TagJump(VALUE self){
	return CommandHandler(F_TAGJUMP, NULL, 0);
}

VALUE __cdecl CRuby::S_TagJumpBack(VALUE self){
	return CommandHandler(F_TAGJUMPBACK, NULL, 0);
}

VALUE __cdecl CRuby::S_TagMake(VALUE self){
	return CommandHandler(F_TAGS_MAKE, NULL, 0);
}

VALUE __cdecl CRuby::S_DirectTagJump(VALUE self){
	return CommandHandler(F_DIRECT_TAGJUMP, NULL, 0);
}

VALUE __cdecl CRuby::S_KeywordTagJump(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_TAGJUMP_KEYWORD, args, 1);
}

VALUE __cdecl CRuby::S_Compare(VALUE self){
	return CommandHandler(F_COMPARE, NULL, 0);
}

VALUE __cdecl CRuby::S_DiffDialog(VALUE self){
	return CommandHandler(F_DIFF_DIALOG, NULL, 0);
}

VALUE __cdecl CRuby::S_Diff(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return CommandHandler(F_DIFF, args, 2);
}

VALUE __cdecl CRuby::S_DiffNext(VALUE self){
	return CommandHandler(F_DIFF_NEXT, NULL, 0);
}

VALUE __cdecl CRuby::S_DiffPrev(VALUE self){
	return CommandHandler(F_DIFF_PREV, NULL, 0);
}

VALUE __cdecl CRuby::S_DiffReset(VALUE self){
	return CommandHandler(F_DIFF_RESET, NULL, 0);
}

VALUE __cdecl CRuby::S_BracketPair(VALUE self){
	return CommandHandler(F_BRACKETPAIR, NULL, 0);
}

VALUE __cdecl CRuby::S_BookmarkSet(VALUE self){
	return CommandHandler(F_BOOKMARK_SET, NULL, 0);
}

VALUE __cdecl CRuby::S_BookmarkNext(VALUE self){
	return CommandHandler(F_BOOKMARK_NEXT, NULL, 0);
}

VALUE __cdecl CRuby::S_BookmarkPrev(VALUE self){
	return CommandHandler(F_BOOKMARK_PREV, NULL, 0);
}

VALUE __cdecl CRuby::S_BookmarkReset(VALUE self){
	return CommandHandler(F_BOOKMARK_RESET, NULL, 0);
}

VALUE __cdecl CRuby::S_BookmarkView(VALUE self){
	return CommandHandler(F_BOOKMARK_VIEW, NULL, 0);
}

VALUE __cdecl CRuby::S_BookmarkPattern(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return CommandHandler(F_BOOKMARK_PATTERN, args, 2);
}

VALUE __cdecl CRuby::S_ChgmodINS(VALUE self){
	return CommandHandler(F_CHGMOD_INS, NULL, 0);
}

VALUE __cdecl CRuby::S_ChgCharSet(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return CommandHandler(F_CHG_CHARSET, args, 2);
}

VALUE __cdecl CRuby::S_ChgmodEOL(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_CHGMOD_EOL, args, 1);
}

VALUE __cdecl CRuby::S_CancelMode(VALUE self){
	return CommandHandler(F_CANCEL_MODE, NULL, 0);
}

VALUE __cdecl CRuby::S_ExecExternalMacro(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return CommandHandler(F_EXECEXTMACRO, args, 2);
}

VALUE __cdecl CRuby::S_ShowToolbar(VALUE self){
	return CommandHandler(F_SHOWTOOLBAR, NULL, 0);
}

VALUE __cdecl CRuby::S_ShowFunckey(VALUE self){
	return CommandHandler(F_SHOWFUNCKEY, NULL, 0);
}

VALUE __cdecl CRuby::S_ShowTab(VALUE self){
	return CommandHandler(F_SHOWTAB, NULL, 0);
}

VALUE __cdecl CRuby::S_ShowStatusbar(VALUE self){
	return CommandHandler(F_SHOWSTATUSBAR, NULL, 0);
}

VALUE __cdecl CRuby::S_TypeList(VALUE self){
	return CommandHandler(F_TYPE_LIST, NULL, 0);
}

VALUE __cdecl CRuby::S_ChangeType(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_CHANGETYPE, args, 1);
}

VALUE __cdecl CRuby::S_OptionType(VALUE self){
	return CommandHandler(F_OPTION_TYPE, NULL, 0);
}

VALUE __cdecl CRuby::S_OptionCommon(VALUE self){
	return CommandHandler(F_OPTION, NULL, 0);
}

VALUE __cdecl CRuby::S_SelectFont(VALUE self){
	return CommandHandler(F_FONT, NULL, 0);
}

VALUE __cdecl CRuby::S_SetFontSize(VALUE self, VALUE arg1, VALUE arg2, VALUE arg3){
	VALUE args[3] = { arg1, arg2, arg3 };
	return CommandHandler(F_SETFONTSIZE, args, 3);
}

VALUE __cdecl CRuby::S_WrapWindowWidth(VALUE self){
	return CommandHandler(F_WRAPWINDOWWIDTH, NULL, 0);
}

VALUE __cdecl CRuby::S_OptionFavorite(VALUE self){
	return CommandHandler(F_FAVORITE, NULL, 0);
}

VALUE __cdecl CRuby::S_SetMsgQuoteStr(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_SET_QUOTESTRING, args, 1);
}

VALUE __cdecl CRuby::S_TextWrapMethod(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_TEXTWRAPMETHOD, args, 1);
}

VALUE __cdecl CRuby::S_SelectCountMode(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_SELECT_COUNT_MODE, args, 1);
}

VALUE __cdecl CRuby::S_ExecCommand(VALUE self, VALUE arg1, VALUE arg2, VALUE arg3){
	VALUE args[3] = { arg1, arg2, arg3 };
	return CommandHandler(F_EXECMD, args, 3);
}

VALUE __cdecl CRuby::S_ExecCommandDialog(VALUE self){
	return CommandHandler(F_EXECMD_DIALOG, NULL, 0);
}

VALUE __cdecl CRuby::S_RMenu(VALUE self){
	return CommandHandler(F_MENU_RBUTTON, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu1(VALUE self){
	return CommandHandler(F_CUSTMENU_1, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu2(VALUE self){
	return CommandHandler(F_CUSTMENU_2, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu3(VALUE self){
	return CommandHandler(F_CUSTMENU_3, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu4(VALUE self){
	return CommandHandler(F_CUSTMENU_4, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu5(VALUE self){
	return CommandHandler(F_CUSTMENU_5, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu6(VALUE self){
	return CommandHandler(F_CUSTMENU_6, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu7(VALUE self){
	return CommandHandler(F_CUSTMENU_7, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu8(VALUE self){
	return CommandHandler(F_CUSTMENU_8, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu9(VALUE self){
	return CommandHandler(F_CUSTMENU_9, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu10(VALUE self){
	return CommandHandler(F_CUSTMENU_10, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu11(VALUE self){
	return CommandHandler(F_CUSTMENU_11, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu12(VALUE self){
	return CommandHandler(F_CUSTMENU_12, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu13(VALUE self){
	return CommandHandler(F_CUSTMENU_13, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu14(VALUE self){
	return CommandHandler(F_CUSTMENU_14, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu15(VALUE self){
	return CommandHandler(F_CUSTMENU_15, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu16(VALUE self){
	return CommandHandler(F_CUSTMENU_16, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu17(VALUE self){
	return CommandHandler(F_CUSTMENU_17, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu18(VALUE self){
	return CommandHandler(F_CUSTMENU_18, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu19(VALUE self){
	return CommandHandler(F_CUSTMENU_19, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu20(VALUE self){
	return CommandHandler(F_CUSTMENU_20, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu21(VALUE self){
	return CommandHandler(F_CUSTMENU_21, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu22(VALUE self){
	return CommandHandler(F_CUSTMENU_22, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu23(VALUE self){
	return CommandHandler(F_CUSTMENU_23, NULL, 0);
}

VALUE __cdecl CRuby::S_CustMenu24(VALUE self){
	return CommandHandler(F_CUSTMENU_24, NULL, 0);
}

VALUE __cdecl CRuby::S_SplitWinV(VALUE self){
	return CommandHandler(F_SPLIT_V, NULL, 0);
}

VALUE __cdecl CRuby::S_SplitWinH(VALUE self){
	return CommandHandler(F_SPLIT_H, NULL, 0);
}

VALUE __cdecl CRuby::S_SplitWinVH(VALUE self){
	return CommandHandler(F_SPLIT_VH, NULL, 0);
}

VALUE __cdecl CRuby::S_WinClose(VALUE self){
	return CommandHandler(F_WINCLOSE, NULL, 0);
}

VALUE __cdecl CRuby::S_WinCloseAll(VALUE self){
	return CommandHandler(F_WIN_CLOSEALL, NULL, 0);
}

VALUE __cdecl CRuby::S_CascadeWin(VALUE self){
	return CommandHandler(F_CASCADE, NULL, 0);
}

VALUE __cdecl CRuby::S_TileWinV(VALUE self){
	return CommandHandler(F_TILE_V, NULL, 0);
}

VALUE __cdecl CRuby::S_TileWinH(VALUE self){
	return CommandHandler(F_TILE_H, NULL, 0);
}

VALUE __cdecl CRuby::S_NextWindow(VALUE self){
	return CommandHandler(F_NEXTWINDOW, NULL, 0);
}

VALUE __cdecl CRuby::S_PrevWindow(VALUE self){
	return CommandHandler(F_PREVWINDOW, NULL, 0);
}

VALUE __cdecl CRuby::S_WindowList(VALUE self){
	return CommandHandler(F_WINLIST, NULL, 0);
}

VALUE __cdecl CRuby::S_MaximizeV(VALUE self){
	return CommandHandler(F_MAXIMIZE_V, NULL, 0);
}

VALUE __cdecl CRuby::S_MaximizeH(VALUE self){
	return CommandHandler(F_MAXIMIZE_H, NULL, 0);
}

VALUE __cdecl CRuby::S_MinimizeAll(VALUE self){
	return CommandHandler(F_MINIMIZE_ALL, NULL, 0);
}

VALUE __cdecl CRuby::S_ReDraw(VALUE self){
	return CommandHandler(F_REDRAW, NULL, 0);
}

VALUE __cdecl CRuby::S_ActivateWinOutput(VALUE self){
	return CommandHandler(F_WIN_OUTPUT, NULL, 0);
}

VALUE __cdecl CRuby::S_TraceOut(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return CommandHandler(F_TRACEOUT, args, 2);
}

VALUE __cdecl CRuby::S_WindowTopMost(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_TOPMOST, args, 1);
}

VALUE __cdecl CRuby::S_GroupClose(VALUE self){
	return CommandHandler(F_GROUPCLOSE, NULL, 0);
}

VALUE __cdecl CRuby::S_NextGroup(VALUE self){
	return CommandHandler(F_NEXTGROUP, NULL, 0);
}

VALUE __cdecl CRuby::S_PrevGroup(VALUE self){
	return CommandHandler(F_PREVGROUP, NULL, 0);
}

VALUE __cdecl CRuby::S_TabMoveRight(VALUE self){
	return CommandHandler(F_TAB_MOVERIGHT, NULL, 0);
}

VALUE __cdecl CRuby::S_TabMoveLeft(VALUE self){
	return CommandHandler(F_TAB_MOVELEFT, NULL, 0);
}

VALUE __cdecl CRuby::S_TabSeparate(VALUE self){
	return CommandHandler(F_TAB_SEPARATE, NULL, 0);
}

VALUE __cdecl CRuby::S_TabJointNext(VALUE self){
	return CommandHandler(F_TAB_JOINTNEXT, NULL, 0);
}

VALUE __cdecl CRuby::S_TabJointPrev(VALUE self){
	return CommandHandler(F_TAB_JOINTPREV, NULL, 0);
}

VALUE __cdecl CRuby::S_TabCloseOther(VALUE self){
	return CommandHandler(F_TAB_CLOSEOTHER, NULL, 0);
}

VALUE __cdecl CRuby::S_TabCloseLeft(VALUE self){
	return CommandHandler(F_TAB_CLOSELEFT, NULL, 0);
}

VALUE __cdecl CRuby::S_TabCloseRight(VALUE self){
	return CommandHandler(F_TAB_CLOSERIGHT, NULL, 0);
}

VALUE __cdecl CRuby::S_Complete(VALUE self){
	return CommandHandler(F_HOKAN, NULL, 0);
}

VALUE __cdecl CRuby::S_ToggleKeyHelpSearch(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_TOGGLE_KEY_SEARCH, args, 1);
}

VALUE __cdecl CRuby::S_HelpContents(VALUE self){
	return CommandHandler(F_HELP_CONTENTS, NULL, 0);
}

VALUE __cdecl CRuby::S_HelpSearch(VALUE self){
	return CommandHandler(F_HELP_SEARCH, NULL, 0);
}

VALUE __cdecl CRuby::S_CommandList(VALUE self){
	return CommandHandler(F_MENU_ALLFUNC, NULL, 0);
}

VALUE __cdecl CRuby::S_ExtHelp1(VALUE self){
	return CommandHandler(F_EXTHELP1, NULL, 0);
}

VALUE __cdecl CRuby::S_ExtHtmlHelp(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return CommandHandler(F_EXTHTMLHELP, args, 2);
}

VALUE __cdecl CRuby::S_About(VALUE self){
	return CommandHandler(F_ABOUT, NULL, 0);
}

VALUE __cdecl CRuby::S_StatusMsg(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return CommandHandler(F_STATUSMSG, args, 2);
}

VALUE __cdecl CRuby::S_MsgBeep(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return CommandHandler(F_MSGBEEP, args, 1);
}

VALUE __cdecl CRuby::S_CommitUndoBuffer(VALUE self){
	return CommandHandler(F_COMMITUNDOBUFFER, NULL, 0);
}

VALUE __cdecl CRuby::S_AddRefUndoBuffer(VALUE self){
	return CommandHandler(F_ADDREFUNDOBUFFER, NULL, 0);
}

VALUE __cdecl CRuby::S_SetUndoBuffer(VALUE self){
	return CommandHandler(F_SETUNDOBUFFER, NULL, 0);
}

VALUE __cdecl CRuby::S_AppendUndoBufferCursor(VALUE self){
	return CommandHandler(F_APPENDUNDOBUFFERCURSOR, NULL, 0);
}

VALUE __cdecl CRuby::S_ClipboardEmpty(VALUE self){
	return CommandHandler(F_CLIPBOARDEMPTY, NULL, 0);
}

VALUE __cdecl CRuby::S_GetFilename(VALUE self){
	return FunctionHandler(F_GETFILENAME, NULL, 0);
}

VALUE __cdecl CRuby::S_GetSaveFilename(VALUE self){
	return FunctionHandler(F_GETSAVEFILENAME, NULL, 0);
}

VALUE __cdecl CRuby::S_GetSelectedString(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return FunctionHandler(F_GETSELECTED, args, 1);
}

VALUE __cdecl CRuby::S_ExpandParameter(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return FunctionHandler(F_EXPANDPARAMETER, args, 1);
}

VALUE __cdecl CRuby::S_GetLineStr(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return FunctionHandler(F_GETLINESTR, args, 1);
}

VALUE __cdecl CRuby::S_GetLineCount(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return FunctionHandler(F_GETLINECOUNT, args, 1);
}

VALUE __cdecl CRuby::S_ChangeTabWidth(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return FunctionHandler(F_CHGTABWIDTH, args, 1);
}

VALUE __cdecl CRuby::S_IsTextSelected(VALUE self){
	return FunctionHandler(F_ISTEXTSELECTED, NULL, 0);
}

VALUE __cdecl CRuby::S_GetSelectLineFrom(VALUE self){
	return FunctionHandler(F_GETSELLINEFROM, NULL, 0);
}

VALUE __cdecl CRuby::S_GetSelectColmFrom(VALUE self){
	return FunctionHandler(F_GETSELCOLUMNFROM, NULL, 0);
}

VALUE __cdecl CRuby::S_GetSelectColumnFrom(VALUE self){
	return FunctionHandler(F_GETSELCOLUMNFROM, NULL, 0);
}

VALUE __cdecl CRuby::S_GetSelectLineTo(VALUE self){
	return FunctionHandler(F_GETSELLINETO, NULL, 0);
}

VALUE __cdecl CRuby::S_GetSelectColmTo(VALUE self){
	return FunctionHandler(F_GETSELCOLUMNTO, NULL, 0);
}

VALUE __cdecl CRuby::S_GetSelectColumnTo(VALUE self){
	return FunctionHandler(F_GETSELCOLUMNTO, NULL, 0);
}

VALUE __cdecl CRuby::S_IsInsMode(VALUE self){
	return FunctionHandler(F_ISINSMODE, NULL, 0);
}

VALUE __cdecl CRuby::S_GetCharCode(VALUE self){
	return FunctionHandler(F_GETCHARCODE, NULL, 0);
}

VALUE __cdecl CRuby::S_GetLineCode(VALUE self){
	return FunctionHandler(F_GETLINECODE, NULL, 0);
}

VALUE __cdecl CRuby::S_IsPossibleUndo(VALUE self){
	return FunctionHandler(F_ISPOSSIBLEUNDO, NULL, 0);
}

VALUE __cdecl CRuby::S_IsPossibleRedo(VALUE self){
	return FunctionHandler(F_ISPOSSIBLEREDO, NULL, 0);
}

VALUE __cdecl CRuby::S_ChangeWrapColm(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return FunctionHandler(F_CHGWRAPCOLUMN, args, 1);
}

VALUE __cdecl CRuby::S_ChangeWrapColumn(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return FunctionHandler(F_CHGWRAPCOLUMN, args, 1);
}

VALUE __cdecl CRuby::S_IsCurTypeExt(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return FunctionHandler(F_ISCURTYPEEXT, args, 1);
}

VALUE __cdecl CRuby::S_IsSameTypeExt(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return FunctionHandler(F_ISSAMETYPEEXT, args, 2);
}

VALUE __cdecl CRuby::S_InputBox(VALUE self, VALUE arg1, VALUE arg2, VALUE arg3){
	VALUE args[3] = { arg1, arg2, arg3 };
	return FunctionHandler(F_INPUTBOX, args, 3);
}

VALUE __cdecl CRuby::S_MessageBox(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return FunctionHandler(F_MESSAGEBOX, args, 2);
}

VALUE __cdecl CRuby::S_ErrorMsg(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return FunctionHandler(F_ERRORMSG, args, 1);
}

VALUE __cdecl CRuby::S_WarnMsg(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return FunctionHandler(F_WARNMSG, args, 1);
}

VALUE __cdecl CRuby::S_InfoMsg(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return FunctionHandler(F_INFOMSG, args, 1);
}

VALUE __cdecl CRuby::S_OkCancelBox(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return FunctionHandler(F_OKCANCELBOX, args, 1);
}

VALUE __cdecl CRuby::S_YesNoBox(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return FunctionHandler(F_YESNOBOX, args, 1);
}

VALUE __cdecl CRuby::S_CompareVersion(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return FunctionHandler(F_COMPAREVERSION, args, 2);
}

VALUE __cdecl CRuby::S_Sleep(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return FunctionHandler(F_MACROSLEEP, args, 1);
}

VALUE __cdecl CRuby::S_FileOpenDialog(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return FunctionHandler(F_FILEOPENDIALOG, args, 2);
}

VALUE __cdecl CRuby::S_FileSaveDialog(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return FunctionHandler(F_FILESAVEDIALOG, args, 2);
}

VALUE __cdecl CRuby::S_FolderDialog(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return FunctionHandler(F_FOLDERDIALOG, args, 2);
}

VALUE __cdecl CRuby::S_GetClipboard(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return FunctionHandler(F_GETCLIPBOARD, args, 1);
}

VALUE __cdecl CRuby::S_SetClipboard(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return FunctionHandler(F_SETCLIPBOARD, args, 2);
}

VALUE __cdecl CRuby::S_LayoutToLogicLineNum(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return FunctionHandler(F_LAYOUTTOLOGICLINENUM, args, 1);
}

VALUE __cdecl CRuby::S_LogicToLayoutLineNum(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return FunctionHandler(F_LOGICTOLAYOUTLINENUM, args, 2);
}

VALUE __cdecl CRuby::S_LineColumnToIndex(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return FunctionHandler(F_LINECOLUMNTOINDEX, args, 2);
}

VALUE __cdecl CRuby::S_LineIndexToColumn(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return FunctionHandler(F_LINEINDEXTOCOLUMN, args, 2);
}

VALUE __cdecl CRuby::S_GetCookie(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return FunctionHandler(F_GETCOOKIE, args, 2);
}

VALUE __cdecl CRuby::S_GetCookieDefault(VALUE self, VALUE arg1, VALUE arg2, VALUE arg3){
	VALUE args[3] = { arg1, arg2, arg3 };
	return FunctionHandler(F_GETCOOKIEDEFAULT, args, 3);
}

VALUE __cdecl CRuby::S_SetCookie(VALUE self, VALUE arg1, VALUE arg2, VALUE arg3){
	VALUE args[3] = { arg1, arg2, arg3 };
	return FunctionHandler(F_SETCOOKIE, args, 3);
}

VALUE __cdecl CRuby::S_DeleteCookie(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return FunctionHandler(F_DELETECOOKIE, args, 2);
}

VALUE __cdecl CRuby::S_GetCookieNames(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return FunctionHandler(F_GETCOOKIENAMES, args, 1);
}

VALUE __cdecl CRuby::S_SetDrawSwitch(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return FunctionHandler(F_SETDRAWSWITCH, args, 1);
}

VALUE __cdecl CRuby::S_GetDrawSwitch(VALUE self){
	return FunctionHandler(F_GETDRAWSWITCH, NULL, 0);
}

VALUE __cdecl CRuby::S_IsShownStatus(VALUE self){
	return FunctionHandler(F_ISSHOWNSTATUS, NULL, 0);
}

VALUE __cdecl CRuby::S_GetStrWidth(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return FunctionHandler(F_GETSTRWIDTH, args, 2);
}

VALUE __cdecl CRuby::S_GetStrLayoutLength(VALUE self, VALUE arg1, VALUE arg2){
	VALUE args[2] = { arg1, arg2 };
	return FunctionHandler(F_GETSTRLAYOUTLENGTH, args, 2);
}

VALUE __cdecl CRuby::S_GetDefaultCharLength(VALUE self){
	return FunctionHandler(F_GETDEFAULTCHARLENGTH, NULL, 0);
}

VALUE __cdecl CRuby::S_IsIncludeClipboardFormat(VALUE self, VALUE arg1){
	VALUE args[1] = { arg1 };
	return FunctionHandler(F_ISINCLUDECLIPBOARDFORMAT, args, 1);
}

VALUE __cdecl CRuby::S_GetClipboardByFormat(VALUE self, VALUE arg1, VALUE arg2, VALUE arg3){
	VALUE args[3] = { arg1, arg2, arg3 };
	return FunctionHandler(F_GETCLIPBOARDBYFORMAT, args, 3);
}

VALUE __cdecl CRuby::S_SetClipboardByFormat(VALUE self, VALUE arg1, VALUE arg2, VALUE arg3, VALUE arg4){
	VALUE args[4] = { arg1, arg2, arg3, arg4 };
	return FunctionHandler(F_SETCLIPBOARDBYFORMAT, args, 4);
}
